var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { m as main, l as lib, j as js, d as docxtemplater, F as FileSaver_min } from "./main.js";
import { a as assign, i as isFunction, o as omitBy, b as isNil } from "./lodash.js";
import { d as dayjs } from "./dayjs.min.js";
import { s as sha1 } from "./sha1.js";
import { utils, writeFile as writeFileSync } from "./xlsx.js";
import "./_commonjsHelpers.js";
const asyncScript = (src) => new Promise((resolve) => {
  var _a;
  const d = document;
  const g = d.createElement("script");
  const s = d.getElementsByTagName("script")[0];
  g.type = "text/javascript";
  g.async = true;
  g.defer = true;
  g.src = src;
  g.onload = () => {
    resolve(true);
  };
  (_a = s == null ? void 0 : s.parentNode) == null ? void 0 : _a.insertBefore(g, s);
});
const ExportBriefDataDocx = (tempDocxPath, data, fileName) => {
  main.filters.lower = function(input) {
    if (!input)
      return input;
    return input.toLowerCase();
  };
  function angularParser(tag) {
    tag = tag.replace(/^\.$/, "this").replace(/(’|‘)/g, "'").replace(/(“|”)/g, '"');
    const expr = main.compile(tag);
    return {
      get: function(scope, context) {
        let obj = {};
        const scopeList = context.scopeList;
        const num = context.num;
        for (let i = 0, len = num + 1; i < len; i++) {
          obj = assign(obj, scopeList[i]);
        }
        return expr(scope, obj);
      }
    };
  }
  lib.getBinaryContent(tempDocxPath, (error, content) => {
    if (error) {
      console.log(error);
    }
    const zip = new js(content);
    const doc = new docxtemplater(zip, { parser: angularParser });
    doc.setData(data);
    try {
      doc.render();
    } catch (error2) {
      const e = {
        message: error2.message,
        name: error2.name,
        stack: error2.stack,
        properties: error2.properties
      };
      console.log({ error: e });
      throw error2;
    }
    const out = doc.getZip().generate({
      type: "blob",
      mimeType: "application/vnd.openxmlformats-officedocument.wordprocessingml.document"
    });
    FileSaver_min.exports.saveAs(out, fileName);
  });
};
const asyncAmapMap = () => new Promise((resolve) => {
  var _a;
  window.onAmapLoad = () => {
    resolve(true);
  };
  if ((_a = window == null ? void 0 : window.AMap) == null ? void 0 : _a.Map) {
    return resolve(true);
  }
});
const _AMapInteractor = class {
  constructor() {
    __publicField(this, "_amap");
    __publicField(this, "_amapMarker");
    __publicField(this, "_curruntLocation");
    this._amap = new window.AMap.Map("amap-container", {
      resizeEnable: true,
      zoom: 10
    });
  }
  static async getInstance() {
    if (!this._instance) {
      await asyncScript(this._amapSrc);
      await asyncAmapMap();
      this._instance = new _AMapInteractor();
    }
    return Promise.resolve(this._instance);
  }
  destroyed() {
    this._amap.destroy();
    delete this._amap;
    _AMapInteractor._instance = null;
  }
  search(city, input, callback, tips = true) {
    const autoOptions = {
      map: this._amap,
      city: city || "\u5168\u56FD",
      extensions: "all"
    };
    if (!tips) {
      delete autoOptions.map;
    }
    const placeSearch = new window.AMap.PlaceSearch(autoOptions);
    placeSearch.search(input, callback);
  }
  getGeocoderAddress(lngLat, callback) {
    window.AMap.plugin("AMap.Geocoder", () => {
      const geocoder = new window.AMap.Geocoder({
        map: this._amap,
        city: "\u5168\u56FD"
      });
      geocoder.getAddress(lngLat, callback);
    });
  }
  updateMarker(lngLat) {
    const marker = this._getMarker();
    marker.setPosition(lngLat);
    marker.setAnimation("AMAP_ANIMATION_DROP");
  }
  getMarkPosition() {
    const marker = this._getMarker();
    const position = marker.getPosition();
    if (position == null ? void 0 : position.lng) {
      return [position == null ? void 0 : position.lng, position == null ? void 0 : position.lat];
    }
    return [];
  }
  autolocation() {
    return new Promise((resolve, reject) => {
      var _a;
      if (this._curruntLocation) {
        resolve(this._curruntLocation);
        return;
      }
      (_a = this._amap) == null ? void 0 : _a.plugin("AMap.Geolocation", () => {
        const geolocation = new window.AMap.Geolocation({
          enableHighAccuracy: true,
          timeout: 1e5,
          buttonOffset: new window.AMap.Pixel(10, 20),
          zoomToAccuracy: true,
          buttonPosition: "RB",
          showCircle: false
        });
        geolocation.options.markerOptions.bubble = true;
        this._amap.addControl(geolocation);
        geolocation.getCurrentPosition();
        window.AMap.event.addListener(geolocation, "complete", (data) => {
          this._curruntLocation = data;
          resolve(data);
        });
        window.AMap.event.addListener(geolocation, "error", (error) => {
          console.warn("\u83B7\u53D6\u5B9A\u4F4D\u5931\u8D25", error);
          reject(error);
        });
      });
    });
  }
  getCurrentProvince() {
    return new Promise((resolve, reject) => {
      this.autolocation().then((data) => {
        const address = data.formattedAddress.slice(0, 2);
        import("./carMessageData.js").then((jsonData) => {
          const provinceData = jsonData.provinceData;
          for (const i in provinceData) {
            if (provinceData[i].province.slice(0, 2) === address) {
              if (data.formattedAddress.indexOf(provinceData[i].city) !== -1) {
                const provinceName = provinceData[i].letter.slice(0, 1);
                const letter = provinceData[i].letter.slice(1, 2);
                resolve({
                  province: provinceName,
                  letter
                });
                break;
              }
            }
          }
        }).catch((err) => {
          reject(err);
        });
      }).catch((err) => {
        reject(err);
      });
    });
  }
  _getMarker() {
    if (!this._amapMarker) {
      this._amapMarker = new window.AMap.Marker({ map: this._amap });
    }
    return this._amapMarker;
  }
  get amap() {
    return this._amap;
  }
};
let AMapInteractor = _AMapInteractor;
__publicField(AMapInteractor, "_instance", null);
__publicField(AMapInteractor, "_amapSrc", "https://webapi.amap.com/maps?v=1.3&key=2c7be58cca107ce087d7ef41a875a65f&plugin=AMap.Geocoder,AMap.Autocomplete,AMap.PlaceSearch,AMap.Geolocation&callback=onAmapLoad");
const checkFileType = (file) => new Promise((resolve, reject) => {
  if (!file) {
    reject("\u8BF7\u4E0A\u4F20\u6587\u4EF6");
    return;
  }
  if (!/\.(xls|xlsx|csv)$/.test(file.name.toLowerCase())) {
    reject("\u6587\u4EF6\u4E0A\u4F20\u5931\u8D25\uFF0C\u8BF7\u68C0\u67E5\u4F60\u7684\u6587\u4EF6\u683C\u5F0F");
    return false;
  }
  if (file.size >= 3145728) {
    reject("\u6587\u4EF6\u4E0A\u4F20\u5931\u8D25\uFF0C\u5927\u5C0F\u4E0D\u80FD\u8D85\u8FC73M");
    return false;
  }
  resolve(true);
});
const readFile = (file, options) => new Promise((resolve, reject) => {
  try {
    const fileReader = new FileReader();
    fileReader.onload = (ev) => {
      var _a;
      const result = (_a = ev.target) == null ? void 0 : _a.result;
      if (!result) {
        resolve([]);
      }
      import("./xlsx.js").then((XLSX) => {
        const workbook = XLSX.read(result, options);
        const fileData = workbook.SheetNames.map((sheepName) => {
          var _a2;
          return XLSX.utils.sheet_to_json((_a2 = workbook.Sheets) == null ? void 0 : _a2[sheepName]);
        });
        resolve(fileData);
      });
    };
    fileReader.readAsBinaryString(file);
  } catch (err) {
    reject(err);
  }
});
const getXlsxFileData = (file, options) => new Promise((resolve, reject) => {
  checkFileType(file).then(() => {
    readFile(file, options).then((fileData) => {
      resolve(fileData);
    });
  }).catch((err) => reject(err));
});
const SUPPORT_IMAGE_TYPE_LIST = ["image/png", "image/jpeg", "image/gif"];
var ImageUploadErrorCodeEnum = /* @__PURE__ */ ((ImageUploadErrorCodeEnum2) => {
  ImageUploadErrorCodeEnum2[ImageUploadErrorCodeEnum2["none"] = 0] = "none";
  ImageUploadErrorCodeEnum2[ImageUploadErrorCodeEnum2["unSupportType"] = 1] = "unSupportType";
  ImageUploadErrorCodeEnum2[ImageUploadErrorCodeEnum2["onlyOne"] = 2] = "onlyOne";
  return ImageUploadErrorCodeEnum2;
})(ImageUploadErrorCodeEnum || {});
const TARGET_IPHONE_VERSION = 13.4;
const checkType = (files) => {
  return files.every((file) => SUPPORT_IMAGE_TYPE_LIST.includes(file.type));
};
const checkUploadRules = (files, isMultiple) => {
  return new Promise((resolve, reject) => {
    const fileLength = files.length;
    if (!isMultiple && fileLength > 1) {
      reject({
        code: 2,
        message: "\u6BCF\u6B21\u53EA\u80FD\u4E0A\u4F20\u4E00\u5F20\u56FE\u7247\uFF0C\u8BF7\u91CD\u65B0\u9009\u62E9"
      });
      return;
    }
    if (!files || fileLength <= 0) {
      reject({
        code: 0,
        message: "\u672A\u83B7\u53D6\u5230\u56FE\u7247\uFF0C\u8BF7\u91CD\u65B0\u9009\u62E9"
      });
      return;
    }
    if (!checkType(files)) {
      reject({
        code: 1,
        message: "\u6587\u4EF6\u7C7B\u578B\u4E0D\u652F\u6301, \u8BF7\u91CD\u65B0\u9009\u62E9"
      });
      return;
    }
    resolve(true);
  });
};
const base64toBlob = (dataurl) => {
  var _a;
  const arr = dataurl.split(",");
  const mime = (_a = arr[0].match(/:(.*?);/)) == null ? void 0 : _a[1];
  const bstr = atob(arr[1]);
  let n = bstr.length;
  const u8arr = new Uint8Array(n);
  while (n--) {
    u8arr[n] = bstr.charCodeAt(n);
  }
  return new Blob([u8arr], { type: mime });
};
const urlToBase64 = (url) => {
  return new Promise((resolve, reject) => {
    import("./index2.js").then(function(n) {
      return n.i;
    }).then(async (imageConversion) => {
      imageConversion.urltoBlob(url).then((file) => {
        imageConversion.filetoDataURL(file).then((base64Data) => {
          resolve(base64Data);
        }).catch(reject);
      }).catch(reject);
    });
  });
};
const base64ToFile = (base64Data, imgName) => {
  try {
    const blob = base64toBlob(base64Data);
    return new File([blob], imgName);
  } catch (err) {
    console.error(err);
    return null;
  }
};
const getOrientation = (file) => {
  return new Promise((resolve, reject) => {
    const userAgent = window.navigator.userAgent.toLowerCase();
    const uaMatch = userAgent.match(/cpu iphone os (.*?) like mac os/);
    const iosVersion = uaMatch ? uaMatch[1].replace(/^(\d+)_(\d+)\S*/, "$1.$2") : "0";
    if (uaMatch && parseInt(iosVersion, 10) < TARGET_IPHONE_VERSION) {
      try {
        import("./index2.js").then(function(n) {
          return n.i;
        }).then(async (imageConversion) => {
          var _a;
          const dataURL = (_a = await imageConversion.filetoDataURL(file).catch(reject)) != null ? _a : "";
          const image = await imageConversion.dataURLtoImage(dataURL).catch(reject);
          import("./exif.js").then((EXIF) => {
            let orient;
            EXIF.default.getData(image, () => {
              orient = EXIF.default.getTag(image, "Orientation");
              resolve(orient);
            });
          });
        });
      } catch (err) {
        resolve(void 0);
      }
    } else {
      return resolve(void 0);
    }
  });
};
const compressFileToDataURL = (file, size = 500) => {
  return new Promise((resolve, reject) => {
    import("./index2.js").then(function(n) {
      return n.i;
    }).then(async (imageConversion) => {
      var _a, _b;
      console.time("compressFileToDataURL");
      const orientation = (_a = await getOrientation(file).catch(reject)) != null ? _a : 0;
      const compressFile2 = await imageConversion.compressAccurately(
        file,
        { size, orientation }
      ).catch(reject);
      if (compressFile2) {
        const dataURL = (_b = await imageConversion.filetoDataURL(compressFile2).catch(reject)) != null ? _b : "";
        console.log(
          `%c\u538B\u7F29\u6587\u4EF6\u4E3Abase64 %c${file.size / 1024}KB >>> ${compressFile2.size / 1024}KB`,
          "color:blue",
          "color:green"
        );
        console.timeEnd("compressFileToDataURL");
        resolve({
          dataURL,
          compressFile: compressFile2,
          fileName: file.name,
          fileType: file.type
        });
      }
    });
  });
};
const compressFile = (file, size = 500) => {
  return new Promise((resolve, reject) => {
    import("./index2.js").then(function(n) {
      return n.i;
    }).then(async (imageConversion) => {
      var _a;
      const orientation = (_a = await getOrientation(file).catch(reject)) != null ? _a : 0;
      const imageFile = await imageConversion.compress(file, { size, orientation }).catch(reject);
      if (imageFile) {
        console.log(
          `%c\u538B\u7F29\u6587\u4EF6 %c${file.size / 1024}KB >>> ${imageFile.size / 1024}KB`,
          "color:blue",
          "color:green"
        );
        resolve(new File([imageFile], file.name));
      }
    });
  });
};
const compressCanvesToFile = (canvasEle, filename = "example.jpg", size = 500) => {
  return new Promise((resolve, reject) => {
    import("./index2.js").then(function(n) {
      return n.i;
    }).then(async (imageConversion) => {
      console.time("compressFileToDataURL");
      imageConversion.canvastoFile(canvasEle, 0.8).then((file) => {
        imageConversion.compress(file, size).then((imageFile) => {
          console.log(
            `%c\u538B\u7F29\u6587\u4EF6 %c${file.size / 1024}KB >>> ${imageFile.size / 1024}KB`,
            "color:blue",
            "color:green"
          );
          console.timeEnd("compressFileToDataURL");
          resolve(new File([imageFile], filename));
        }).catch(reject);
      }).catch(reject);
    });
  });
};
const compressUploader = async (items) => {
  if (!items) {
    throw Error("\u4E0A\u4F20\u9644\u4EF6\u4E3A\u7A7A");
  }
  let files, isMultiple;
  if (isMultiple = Array.isArray(items)) {
    const uploaderFileList = items;
    if (!uploaderFileList.every((item) => item.file)) {
      throw Error("\u4E0A\u4F20\u9644\u4EF6\u5B58\u5728\u7A7A\u6587\u4EF6");
    }
    files = uploaderFileList.map((item) => item.file);
  } else {
    const uploaderFile = items;
    if (!uploaderFile.file) {
      throw Error("\u4E0A\u4F20\u9644\u4EF6\u4E3A\u7A7A\u6587\u4EF6");
    }
    files = [uploaderFile.file];
  }
  const isChecked = checkUploadRules(files, isMultiple);
  if (!isChecked) {
    throw Error("\u9644\u4EF6\u68C0\u67E5\u65E0\u6548");
  }
  const result = [];
  for (const file of files) {
    const imageData = await compressFileToDataURL(file).catch(Promise.reject);
    result.push(imageData);
  }
  return result;
};
const getImageData = (e, isMultiple = false) => {
  const target = e.target;
  const result = [];
  const files = Array.prototype.slice.call(target.files);
  const fileLength = files.length;
  return new Promise((resolve, reject) => {
    checkUploadRules(files, isMultiple).then(() => {
      files.forEach((file) => {
        compressFileToDataURL(file).then((imageData) => {
          result.push(imageData);
          if (result.length === fileLength) {
            resolve(result);
            target.value = "";
          }
        });
      });
    }).catch((err) => {
      reject(err);
    });
  });
};
const getBrowserFeature = () => {
  var _a;
  const navigatorAlias = navigator || {};
  const windowAlias = window || {};
  const screenAlias = windowAlias.screen || {};
  const pluginMap = {
    pdf: "application/pdf",
    qt: "video/quicktime",
    realp: "audio/x-pn-realaudio-plugin",
    wma: "application/x-mplayer2",
    dir: "application/x-director",
    fla: "application/x-shockwave-flash",
    java: "application/x-java-vm",
    gears: "application/x-googlegears",
    ag: "application/x-silverlight"
  };
  const browserFeature = {
    pdf: "",
    qt: "",
    realp: "",
    wma: "",
    dir: "",
    fla: "",
    res: "",
    java: "",
    gears: "",
    cookie: "",
    ag: ""
  };
  if (!new RegExp("MSIE").test(navigatorAlias.userAgent)) {
    if ((_a = navigatorAlias.mimeTypes) == null ? void 0 : _a.length) {
      for (const i in pluginMap) {
        if (Object.prototype.hasOwnProperty.call(pluginMap, i)) {
          const mimeType = navigatorAlias.mimeTypes[pluginMap[i]];
          browserFeature[i] = (mimeType == null ? void 0 : mimeType.enabledPlugin) ? "1" : "0";
        }
      }
    }
    if (isFunction(navigatorAlias.javaEnabled) && navigatorAlias.javaEnabled()) {
      browserFeature.java = "1";
    }
    if (isFunction(windowAlias.GearsFactory)) {
      browserFeature.gears = "1";
    }
    browserFeature.cookie = navigatorAlias.cookieEnabled ? "1" : "0";
  }
  const width = screenAlias.width;
  const height = screenAlias.height;
  browserFeature.res = width + "x" + height;
  return browserFeature;
};
const uuid = () => {
  const navigatorAlias = navigator || {};
  return sha1(`
    ${dayjs().valueOf()}
    ${navigatorAlias.userAgent || ""}
    ${navigatorAlias.platform || ""}
    ${JSON.stringify(getBrowserFeature())}
    ${Math.random()}`);
};
const _EnvUtils = class {
  static setProHost(host) {
    _EnvUtils.proHost = host;
  }
  static isPro() {
    return document.domain === _EnvUtils.proHost || window.location.host === _EnvUtils.proHost;
  }
};
let EnvUtils = _EnvUtils;
__publicField(EnvUtils, "ua", navigator ? navigator.userAgent.toLowerCase() : "");
__publicField(EnvUtils, "screen", window ? window.screen : {
  height: 0,
  width: 0
});
__publicField(EnvUtils, "isWx", () => /micromessenger/i.test(_EnvUtils.ua));
__publicField(EnvUtils, "isAndroid", () => /android/i.test(_EnvUtils.ua));
__publicField(EnvUtils, "isIphone", () => /iphone/i.test(_EnvUtils.ua));
__publicField(EnvUtils, "isIphoneX", () => _EnvUtils.isIphone() && _EnvUtils.screen.height === 812 && _EnvUtils.screen.width === 375);
__publicField(EnvUtils, "isIphone678", () => _EnvUtils.isIphone() && _EnvUtils.screen.height === 667 && _EnvUtils.screen.width === 375);
__publicField(EnvUtils, "isIphone678Plus", () => _EnvUtils.isIphone() && _EnvUtils.screen.height === 736 && _EnvUtils.screen.width === 414);
__publicField(EnvUtils, "isIphone5", () => _EnvUtils.isIphone() && _EnvUtils.screen.height === 568 && _EnvUtils.screen.width === 320);
__publicField(EnvUtils, "iPhoneSystemVersion", () => {
  const uaMatch = _EnvUtils.ua.match(/cpu iphone os (.*?) like mac os/);
  const iosVersion = uaMatch ? uaMatch[1].replace(/^(\d+)_(\d+)\S*/, "$1.$2") : "0";
  return parseInt(iosVersion, 10);
});
__publicField(EnvUtils, "proHost", "");
const _WechatSdk = class {
  static getInstance() {
    return new Promise((resolve) => {
      if (_WechatSdk._wechatSdk) {
        resolve(this._wechatSdk);
      } else {
        import("./index4.js").then(function(n) {
          return n.i;
        }).then((wx) => {
          _WechatSdk._wechatSdk = wx;
          resolve(wx);
          window.wx = wx;
        });
      }
    });
  }
};
let WechatSdk = _WechatSdk;
__publicField(WechatSdk, "_wechatSdk", null);
const getUrlQuerys = (search) => {
  let queryString = search || (window == null ? void 0 : window.location.search);
  if (!queryString) {
    return {};
  }
  if (queryString[0] === "?") {
    queryString = queryString.slice(1);
  }
  const queryArr = queryString.split("&");
  const urlParams = {};
  queryArr.forEach((item) => {
    const params = item.split("=");
    if (params[1] && params[1] !== "undefined") {
      try {
        urlParams[params[0]] = decodeURIComponent(params[1]);
      } catch (e) {
        console.error(e.message);
      }
    }
  });
  return urlParams;
};
const getUrlQuery = (key, search) => {
  const params = getUrlQuerys(search);
  return params[key] || "";
};
const enCodeUrlParams = (params, excules = []) => {
  const paramsArray = [];
  Object.keys(params).forEach((key) => {
    const exculesKeys = [...excules, "returnShopProductUrl"];
    if (exculesKeys.includes(key)) {
      return key;
    }
    if (params[key]) {
      paramsArray.push(
        encodeURIComponent(key) + "=" + encodeURIComponent(params[key])
      );
    } else {
      if (typeof params[key] === "number" && !isNaN(Number(params[key]))) {
        paramsArray.push(
          encodeURIComponent(key) + "=" + encodeURIComponent(params[key])
        );
      } else {
        paramsArray.push(encodeURIComponent(key) + "=");
      }
    }
  });
  return paramsArray.join("&");
};
const overrideMimeTypeXML = (params) => new Promise((resolve) => {
  let xmlHttp;
  if (window.XMLHttpRequest) {
    xmlHttp = new XMLHttpRequest();
  } else {
    xmlHttp = new window.ActiveXObject("Microsoft.XMLHTTP");
  }
  xmlHttp.open("GET", window.location.origin + params.url, true);
  xmlHttp.overrideMimeType(`text/html;charset=${params.charset}`);
  xmlHttp.send(null);
  xmlHttp.onreadystatechange = () => {
    if (xmlHttp.readyState === 4) {
      if (xmlHttp.status === 200) {
        resolve(xmlHttp.response);
      } else {
        resolve("");
      }
    }
  };
});
const getUrlTemplateCode = () => {
  if (/.*\/product\/([a-zA-Z_]+)\/index.html/gi.test(window == null ? void 0 : window.location.pathname)) {
    const templateCode = window == null ? void 0 : window.location.pathname.replace(
      /.*\/product\/([a-zA-Z_]+)\/index.html/gi,
      "$1"
    );
    return templateCode;
  }
  return getUrlQuery("_from") || "";
};
const DEFAULT_DOCUMENT_TITLE = "xxxxx";
const SCPRIT_ID = "WX_SCRIPT";
const getWechatEnv = (() => {
  const envConfig = {
    isWechat: false,
    isMiniprogram: false
  };
  if (EnvUtils.isWx()) {
    WechatSdk.getInstance().then((wx) => {
      wx.miniProgram.getEnv((res) => {
        if (res.miniprogram) {
          envConfig.isMiniprogram = true;
        } else {
          envConfig.isWechat = true;
        }
      });
    });
  }
  return {
    envConfig
  };
})();
const wechatJsonHandler = (data) => {
  const targetScript = document.getElementById(SCPRIT_ID);
  if (targetScript) {
    document.body.removeChild(targetScript);
  }
  if (data && typeof data === "string") {
    try {
      const response = JSON.parse(data);
      if (!response.signature) {
        return;
      }
      WechatUtils.setWechatJson(response);
      if (!EnvUtils.isWx()) {
        return;
      }
      WechatSdk.getInstance().then((wx) => {
        wx.miniProgram.getEnv((res) => {
          if (!res.miniprogram) {
            WechatUtils.initWechat();
          }
        });
      });
    } catch (err) {
      console.error(`\u5FAE\u4FE1\u521D\u59CB\u5316\u5931\u8D25 ${err}`);
    }
  }
};
class WechatUtils {
  static get config() {
    return EnvUtils.isPro() ? this.WECHAT_SINGE_CONFIG.pro : this.WECHAT_SINGE_CONFIG.test;
  }
  static get _isFinishGetSignature() {
    return !!this._wechatJson.signature;
  }
  static get wechatEnv() {
    return getWechatEnv.envConfig;
  }
  static init() {
    this._retryTime = 0;
    if (!this._isInWechat) {
      return;
    }
    this._getSignatureByJsonp();
  }
  static initShareConfig(config, callback) {
    if (!this._isInWechat) {
      return;
    }
    if (config) {
      this._shareConfig = {
        title: (config == null ? void 0 : config.title) || DEFAULT_DOCUMENT_TITLE,
        desc: (config == null ? void 0 : config.desc) || "xxxxx",
        link: (config == null ? void 0 : config.link) || window.location.href,
        imgUrl: (config == null ? void 0 : config.imgUrl) || `${window.location.origin}/logo.png`,
        callback
      };
      this._retryTimer = 0;
    }
    if (!this._isInitSuccess && this._retryTime < this.MAX_RETRY_TIME) {
      this._retryTime += 1;
      clearTimeout(this._retryTimer);
      this._retryTimer = window.setTimeout(() => {
        this.initShareConfig();
      }, this.RETRY_INTERVAL);
      return;
    }
    const shareObj = {
      title: this._shareConfig.title,
      desc: this._shareConfig.desc,
      link: this._shareConfig.link,
      imgUrl: this._shareConfig.imgUrl,
      trigger: () => {
        console.log("\u7528\u6237\u70B9\u51FB\u53D1\u9001\u7ED9\u670B\u53CB");
      },
      success: () => {
        var _a, _b;
        console.log("\u5206\u4EAB\u6210\u529F");
        (_b = (_a = this._shareConfig).callback) == null ? void 0 : _b.call(_a);
      },
      cancel: () => {
        console.log("\u5DF2\u53D6\u6D88\u5206\u4EAB");
      }
    };
    WechatSdk.getInstance().then((wx) => {
      wx.onMenuShareAppMessage(shareObj);
      wx.onMenuShareQQ(shareObj);
      wx.onMenuShareTimeline(shareObj);
    });
  }
  static setWechatJson(data) {
    this._wechatJson = {
      signature: data.signature,
      timestamp: data.timestamp,
      nonceStr: data.nonce || data.nonceStr,
      ticket: data.ticket,
      nonce: data.nonce
    };
  }
  static initWechat(callback) {
    return new Promise((resolve) => {
      if (!this._isFinishGetSignature) {
        return;
      }
      WechatSdk.getInstance().then((wx) => {
        wx.config({
          debug: false,
          appId: this.config.appid,
          timestamp: this._wechatJson.timestamp,
          nonceStr: this._wechatJson.nonceStr,
          signature: this._wechatJson.signature,
          jsApiList: this.WECHAT_API_LIST
        });
        wx.ready(() => {
          this.initShareConfig();
          this._isInitSuccess = true;
          callback == null ? void 0 : callback();
          resolve(this._wechatJson);
        });
        wx.error((err) => {
          console.log("wx.error", err);
        });
      });
    });
  }
  static getWechatAppType() {
    if (this.wechatEnv.isMiniprogram) {
      return "WMP";
    }
    if (this.wechatEnv.isWechat) {
      return "JSAPI";
    }
    return "H5";
  }
  static _getSignatureByJsonp() {
    WechatSdk.getInstance().then((wx) => {
      wx.miniProgram.getEnv((res) => {
        if (!res.miniprogram) {
          window.wechatJsonHandler = wechatJsonHandler;
          const signUrl = EnvUtils.isAndroid() ? window.location.href.split("#")[0] : this.entryUrl;
          const params = {
            openid: this.config.openid,
            weappNo: this.config.weappNo,
            fxurl: signUrl,
            callback: "window.wechatJsonHandler"
          };
          const script = document.createElement("script");
          script.id = SCPRIT_ID;
          script.src = `${this.config.getSignatureUri}${enCodeUrlParams(params)}`;
          document.body.insertBefore(script, document.body.firstChild);
        }
      });
    });
  }
}
__publicField(WechatUtils, "entryUrl", "");
__publicField(WechatUtils, "WECHAT_API_LIST", [
  "checkJsApi",
  "updateAppMessageShareData",
  "updateTimelineShareData",
  "onMenuShareTimeline",
  "onMenuShareAppMessage",
  "onMenuShareQQ",
  "hideOptionMenu",
  "showOptionMenu",
  "getLocation",
  "chooseImage",
  "uploadImage",
  "downloadImage",
  "previewImage",
  "closeWindow"
]);
__publicField(WechatUtils, "MAX_RETRY_TIME", 5);
__publicField(WechatUtils, "RETRY_INTERVAL", 500);
__publicField(WechatUtils, "WECHAT_SINGE_CONFIG", {
  test: {
    appid: "xxxxx",
    weappNo: "xxxxx",
    redirectUri: "xxxxx/redirect?backUrl=",
    getSignatureUri: "xxxxx/getSignature?",
    openid: "xxxxx"
  },
  pro: {
    appid: "xxxxx",
    weappNo: "xxxxx",
    redirectUri: "http://xxxxx/redirect?backUrl=",
    getSignatureUri: "https://xxxxx/getSignature?",
    openid: "xxxxx"
  }
});
__publicField(WechatUtils, "_wechatJson", {
  signature: "",
  timestamp: "",
  nonce: "",
  ticket: ""
});
__publicField(WechatUtils, "_shareConfig", {
  title: "\u5206\u4EAB\u6807\u9898",
  desc: "\u5206\u4EAB\u5185\u5BB9",
  link: window.location.href,
  imgUrl: `${window.location.origin}/logo.png`,
  callback: () => {
    console.log("share callback");
  }
});
__publicField(WechatUtils, "_isInWechat", EnvUtils.isWx());
__publicField(WechatUtils, "_isInitSuccess", false);
__publicField(WechatUtils, "_retryTime", 0);
__publicField(WechatUtils, "_retryTimer");
const pinyinData = {
  a: "\u554A\u963F\u9515",
  ai: "\u57C3\u6328\u54CE\u5509\u54C0\u7691\u764C\u853C\u77EE\u827E\u788D\u7231\u9698\u8BF6\u6371\u55F3\u55CC\u5AD2\u7477\u66A7\u7839\u953F\u972D",
  an: "\u978D\u6C28\u5B89\u4FFA\u6309\u6697\u5CB8\u80FA\u6848\u8C19\u57EF\u63DE\u72B4\u5EB5\u6849\u94F5\u9E4C\u9878\u9EEF",
  ang: "\u80AE\u6602\u76CE",
  ao: "\u51F9\u6556\u71AC\u7FF1\u8884\u50B2\u5965\u61CA\u6FB3\u5773\u62D7\u55F7\u5662\u5C99\u5ED2\u9068\u5AAA\u9A9C\u8071\u87AF\u93CA\u9CCC\u93D6",
  ba: "\u82AD\u634C\u6252\u53ED\u5427\u7B06\u516B\u75A4\u5DF4\u62D4\u8DCB\u9776\u628A\u8019\u575D\u9738\u7F62\u7238\u8307\u83DD\u8406\u636D\u5C9C\u705E\u6777\u94AF\u7C91\u9C85\u9B43",
  bai: "\u767D\u67CF\u767E\u6446\u4F70\u8D25\u62DC\u7A17\u859C\u63B0\u97B4",
  ban: "\u6591\u73ED\u642C\u6273\u822C\u9881\u677F\u7248\u626E\u62CC\u4F34\u74E3\u534A\u529E\u7ECA\u962A\u5742\u8C73\u94A3\u7622\u764D\u8228",
  bang: "\u90A6\u5E2E\u6886\u699C\u8180\u7ED1\u68D2\u78C5\u868C\u9551\u508D\u8C24\u84A1\u8783",
  bao: "\u82DE\u80DE\u5305\u8912\u96F9\u4FDD\u5821\u9971\u5B9D\u62B1\u62A5\u66B4\u8C79\u9C8D\u7206\u52F9\u8446\u5B80\u5B62\u7172\u9E28\u8913\u8DB5\u9F85",
  bo: "\u5265\u8584\u73BB\u83E0\u64AD\u62E8\u94B5\u6CE2\u535A\u52C3\u640F\u94C2\u7B94\u4F2F\u5E1B\u8236\u8116\u818A\u6E24\u6CCA\u9A73\u4EB3\u8543\u5575\u997D\u6A97\u64D8\u7934\u94B9\u9E41\u7C38\u8DDB",
  bei: "\u676F\u7891\u60B2\u5351\u5317\u8F88\u80CC\u8D1D\u94A1\u500D\u72C8\u5907\u60EB\u7119\u88AB\u5B5B\u9642\u90B6\u57E4\u84D3\u5457\u602B\u6096\u789A\u9E4E\u8919\u943E",
  ben: "\u5954\u82EF\u672C\u7B28\u755A\u574C\u951B",
  beng: "\u5D29\u7EF7\u752D\u6CF5\u8E66\u8FF8\u552A\u5623\u750F",
  bi: "\u903C\u9F3B\u6BD4\u9119\u7B14\u5F7C\u78A7\u84D6\u853D\u6BD5\u6BD9\u6BD6\u5E01\u5E87\u75F9\u95ED\u655D\u5F0A\u5FC5\u8F9F\u58C1\u81C2\u907F\u965B\u5315\u4EF3\u4FFE\u8298\u835C\u8378\u5421\u54D4\u72F4\u5EB3\u610E\u6ED7\u6FDE\u5F3C\u59A3\u5A62\u5B16\u74A7\u8D32\u7540\u94CB\u79D5\u88E8\u7B5A\u7B85\u7BE6\u822D\u895E\u8DF8\u9AC0",
  bian: "\u97AD\u8FB9\u7F16\u8D2C\u6241\u4FBF\u53D8\u535E\u8FA8\u8FA9\u8FAB\u904D\u533E\u5F01\u82C4\u5FED\u6C74\u7F0F\u7178\u782D\u78A5\u7A39\u7A86\u8759\u7B3E\u9CCA",
  biao: "\u6807\u5F6A\u8198\u8868\u5A4A\u9AA0\u98D1\u98D9\u98DA\u706C\u9556\u9573\u762D\u88F1\u9CD4",
  bie: "\u9CD6\u618B\u522B\u762A\u8E69\u9CD8",
  bin: "\u5F6C\u658C\u6FD2\u6EE8\u5BBE\u6448\u50A7\u6D5C\u7F24\u73A2\u6BA1\u8191\u9554\u9ACC\u9B13",
  bing: "\u5175\u51B0\u67C4\u4E19\u79C9\u997C\u70B3\u75C5\u5E76\u7980\u90B4\u6452\u7EE0\u678B\u69DF\u71F9",
  bu: "\u6355\u535C\u54FA\u8865\u57E0\u4E0D\u5E03\u6B65\u7C3F\u90E8\u6016\u62CA\u535F\u900B\u74FF\u6661\u949A\u91AD",
  ca: "\u64E6\u5693\u7924",
  cai: "\u731C\u88C1\u6750\u624D\u8D22\u776C\u8E29\u91C7\u5F69\u83DC\u8521",
  can: "\u9910\u53C2\u8695\u6B8B\u60ED\u60E8\u707F\u9A96\u74A8\u7CB2\u9EEA",
  cang: "\u82CD\u8231\u4ED3\u6CA7\u85CF\u4F27",
  cao: "\u64CD\u7CD9\u69FD\u66F9\u8349\u8279\u5608\u6F15\u87AC\u825A",
  ce: "\u5395\u7B56\u4FA7\u518C\u6D4B\u5202\u5E3B\u607B",
  ceng: "\u5C42\u8E6D\u564C",
  cha: "\u63D2\u53C9\u832C\u8336\u67E5\u78B4\u643D\u5BDF\u5C94\u5DEE\u8BE7\u7339\u9987\u6C4A\u59F9\u6748\u6942\u69CE\u6AAB\u9497\u9538\u9572\u8869",
  chai: "\u62C6\u67F4\u8C7A\u4FAA\u8308\u7625\u867F\u9F87",
  chan: "\u6400\u63BA\u8749\u998B\u8C17\u7F20\u94F2\u4EA7\u9610\u98A4\u5181\u8C04\u8C36\u8487\u5EDB\u5FCF\u6F7A\u6FB6\u5B71\u7FBC\u5A75\u5B17\u9AA3\u89C7\u7985\u9561\u88E3\u87FE\u8E94",
  chang: "\u660C\u7316\u573A\u5C1D\u5E38\u957F\u507F\u80A0\u5382\u655E\u7545\u5531\u5021\u4F25\u9B2F\u82CC\u83D6\u5F9C\u6005\u60DD\u960A\u5A3C\u5AE6\u6636\u6C05\u9CB3",
  chao: "\u8D85\u6284\u949E\u671D\u5632\u6F6E\u5DE2\u5435\u7092\u600A\u7EC9\u6641\u8016",
  che: "\u8F66\u626F\u64A4\u63A3\u5F7B\u6F88\u577C\u5C6E\u7817",
  chen: "\u90F4\u81E3\u8FB0\u5C18\u6668\u5FF1\u6C89\u9648\u8D81\u886C\u79F0\u8C0C\u62BB\u55D4\u5BB8\u741B\u6987\u809C\u80C2\u789C\u9F80",
  cheng: "\u6491\u57CE\u6A59\u6210\u5448\u4E58\u7A0B\u60E9\u6F84\u8BDA\u627F\u901E\u9A8B\u79E4\u57D5\u5D4A\u5FB5\u6D48\u67A8\u67FD\u6A18\u665F\u584D\u77A0\u94D6\u88CE\u86CF\u9172",
  chi: "\u5403\u75F4\u6301\u5319\u6C60\u8FDF\u5F1B\u9A70\u803B\u9F7F\u4F88\u5C3A\u8D64\u7FC5\u65A5\u70BD\u50BA\u5880\u82AA\u830C\u640B\u53F1\u54E7\u557B\u55E4\u5F73\u996C\u6CB2\u5AB8\u6555\u80DD\u7719\u7735\u9E31\u761B\u892B\u86A9\u87AD\u7B1E\u7BEA\u8C49\u8E05\u8E1F\u9B51",
  chong: "\u5145\u51B2\u866B\u5D07\u5BA0\u833A\u5FE1\u61A7\u94F3\u825F",
  chou: "\u62BD\u916C\u7574\u8E0C\u7A20\u6101\u7B79\u4EC7\u7EF8\u7785\u4E11\u4FE6\u5733\u5E31\u60C6\u6EB4\u59AF\u7633\u96E0\u9C8B",
  chu: "\u81ED\u521D\u51FA\u6A71\u53A8\u8E87\u9504\u96CF\u6EC1\u9664\u695A\u7840\u50A8\u77D7\u6410\u89E6\u5904\u4E8D\u520D\u61B7\u7ECC\u6775\u696E\u6A17\u870D\u8E70\u9EDC",
  chuan: "\u63E3\u5DDD\u7A7F\u693D\u4F20\u8239\u5598\u4E32\u63BE\u821B\u60F4\u9044\u5DDB\u6C1A\u948F\u9569\u8221",
  chuang: "\u75AE\u7A97\u5E62\u5E8A\u95EF\u521B\u6006",
  chui: "\u5439\u708A\u6376\u9524\u5782\u9672\u68F0\u69CC",
  chun: "\u6625\u693F\u9187\u5507\u6DF3\u7EAF\u8822\u4FC3\u83BC\u6C8C\u80AB\u6710\u9E51\u877D",
  chuo: "\u6233\u7EF0\u851F\u8FB6\u8F8D\u955E\u8E14\u9F8A",
  ci: "\u75B5\u8328\u78C1\u96CC\u8F9E\u6148\u74F7\u8BCD\u6B64\u523A\u8D50\u6B21\u8360\u5472\u5D6F\u9E5A\u8785\u7CCD\u8D91",
  cong: "\u806A\u8471\u56F1\u5306\u4ECE\u4E1B\u506C\u82C1\u6DD9\u9AA2\u742E\u7481\u679E",
  cu: "\u51D1\u7C97\u918B\u7C07\u731D\u6B82\u8E59",
  cuan: "\u8E7F\u7BE1\u7A9C\u6C46\u64BA\u6615\u7228",
  cui: "\u6467\u5D14\u50AC\u8106\u7601\u7CB9\u6DEC\u7FE0\u8403\u60B4\u7480\u69B1\u96B9",
  cun: "\u6751\u5B58\u5BF8\u78CB\u5FD6\u76B4",
  cuo: "\u64AE\u6413\u63AA\u632B\u9519\u539D\u811E\u9509\u77EC\u75E4\u9E7E\u8E49\u8E9C",
  da: "\u642D\u8FBE\u7B54\u7629\u6253\u5927\u8037\u54D2\u55D2\u601B\u59B2\u75B8\u8921\u7B2A\u977C\u9791",
  dai: "\u5446\u6B79\u50A3\u6234\u5E26\u6B86\u4EE3\u8D37\u888B\u5F85\u902E\u6020\u57ED\u7519\u5454\u5CB1\u8FE8\u902F\u9A80\u7ED0\u73B3\u9EDB",
  dan: "\u803D\u62C5\u4E39\u5355\u90F8\u63B8\u80C6\u65E6\u6C2E\u4F46\u60EE\u6DE1\u8BDE\u5F39\u86CB\u4EBB\u510B\u5369\u840F\u5556\u6FB9\u6A90\u6B9A\u8D55\u7708\u7605\u8043\u7BAA",
  dang: "\u5F53\u6321\u515A\u8361\u6863\u8C20\u51FC\u83EA\u5B95\u7800\u94DB\u88C6",
  dao: "\u5200\u6363\u8E48\u5012\u5C9B\u7977\u5BFC\u5230\u7A3B\u60BC\u9053\u76D7\u53E8\u5541\u5FC9\u6D2E\u6C18\u7118\u5FD1\u7E9B",
  de: "\u5FB7\u5F97\u7684\u951D",
  deng: "\u8E6C\u706F\u767B\u7B49\u77AA\u51F3\u9093\u5654\u5D9D\u6225\u78F4\u956B\u7C26",
  di: "\u5824\u4F4E\u6EF4\u8FEA\u654C\u7B1B\u72C4\u6DA4\u7FDF\u5AE1\u62B5\u5E95\u5730\u8482\u7B2C\u5E1D\u5F1F\u9012\u7F14\u6C10\u7C74\u8BCB\u8C1B\u90B8\u577B\u839C\u837B\u5600\u5A23\u67E2\u68E3\u89CC\u7825\u78B2\u7747\u955D\u7F9D\u9AB6",
  dian: "\u98A0\u6382\u6EC7\u7898\u70B9\u5178\u975B\u57AB\u7535\u4F43\u7538\u5E97\u60E6\u5960\u6DC0\u6BBF\u4E36\u963D\u576B\u57DD\u5DC5\u73B7\u765C\u766B\u7C1F\u8E2E",
  diao: "\u7889\u53FC\u96D5\u51CB\u5201\u6389\u540A\u9493\u8C03\u8F7A\u94DE\u8729\u7C9C\u8C82",
  die: "\u8DCC\u7239\u789F\u8776\u8FED\u8C0D\u53E0\u4F5A\u57A4\u581E\u63F2\u558B\u6E2B\u8F76\u7252\u74DE\u8936\u800B\u8E40\u9CBD\u9CCE",
  ding: "\u4E01\u76EF\u53EE\u9489\u9876\u9F0E\u952D\u5B9A\u8BA2\u4E22\u4EC3\u5576\u738E\u815A\u7887\u753A\u94E4\u7594\u8035\u914A",
  dong: "\u4E1C\u51AC\u8463\u61C2\u52A8\u680B\u4F97\u606B\u51BB\u6D1E\u578C\u549A\u5CBD\u5CD2\u5902\u6C21\u80E8\u80F4\u7850\u9E2B",
  dou: "\u515C\u6296\u6597\u9661\u8C46\u9017\u75D8\u8538\u94AD\u7AA6\u7AAC\u86AA\u7BFC\u9161",
  du: "\u90FD\u7763\u6BD2\u728A\u72EC\u8BFB\u5835\u7779\u8D4C\u675C\u9540\u809A\u5EA6\u6E21\u5992\u828F\u561F\u6E0E\u691F\u6A50\u724D\u8839\u7B03\u9AD1\u9EE9",
  duan: "\u7AEF\u77ED\u953B\u6BB5\u65AD\u7F0E\u5F56\u6934\u7145\u7C16",
  dui: "\u5806\u5151\u961F\u5BF9\u603C\u619D\u7893",
  dun: "\u58A9\u5428\u8E72\u6566\u987F\u56E4\u949D\u76FE\u9041\u7096\u7818\u7905\u76F9\u9566\u8DB8",
  duo: "\u6387\u54C6\u591A\u593A\u579B\u8EB2\u6735\u8DFA\u8235\u5241\u60F0\u5815\u5484\u54DA\u7F0D\u67C1\u94CE\u88F0\u8E31",
  e: "\u86FE\u5CE8\u9E45\u4FC4\u989D\u8BB9\u5A25\u6076\u5384\u627C\u904F\u9102\u997F\u5669\u8C14\u57A9\u57AD\u82CA\u83AA\u843C\u5443\u6115\u5C59\u5A40\u8F6D\u66F7\u816D\u786A\u9507\u9537\u9E57\u989A\u9CC4",
  en: "\u6069\u84BD\u6441\u5514\u55EF",
  er: "\u800C\u513F\u8033\u5C14\u9975\u6D31\u4E8C\u8D30\u8FE9\u73E5\u94D2\u9E38\u9C95",
  fa: "\u53D1\u7F5A\u7B4F\u4F10\u4E4F\u9600\u6CD5\u73D0\u57A1\u781D",
  fan: "\u85E9\u5E06\u756A\u7FFB\u6A0A\u77FE\u9492\u7E41\u51E1\u70E6\u53CD\u8FD4\u8303\u8D29\u72AF\u996D\u6CDB\u8629\u5E61\u72AD\u68B5\u6535\u71D4\u7548\u8E6F",
  fang: "\u574A\u82B3\u65B9\u80AA\u623F\u9632\u59A8\u4EFF\u8BBF\u7EBA\u653E\u531A\u90A1\u5F77\u94AB\u822B\u9C82",
  fei: "\u83F2\u975E\u5561\u98DE\u80A5\u532A\u8BFD\u5420\u80BA\u5E9F\u6CB8\u8D39\u82BE\u72D2\u60B1\u6DDD\u5983\u7ECB\u7EEF\u69A7\u8153\u6590\u6249\u7953\u7829\u9544\u75F1\u871A\u7BDA\u7FE1\u970F\u9CB1",
  fen: "\u82AC\u915A\u5429\u6C1B\u5206\u7EB7\u575F\u711A\u6C7E\u7C89\u594B\u4EFD\u5FFF\u6124\u7CAA\u507E\u7035\u68FC\u610D\u9CBC\u9F22",
  feng: "\u4E30\u5C01\u67AB\u8702\u5CF0\u950B\u98CE\u75AF\u70FD\u9022\u51AF\u7F1D\u8BBD\u5949\u51E4\u4FF8\u9146\u8451\u6CA3\u781C",
  fu: "\u4F5B\u5426\u592B\u6577\u80A4\u5B75\u6276\u62C2\u8F90\u5E45\u6C1F\u7B26\u4F0F\u4FD8\u670D\u6D6E\u6DAA\u798F\u88B1\u5F17\u752B\u629A\u8F85\u4FEF\u91DC\u65A7\u812F\u8151\u5E9C\u8150\u8D74\u526F\u8986\u8D4B\u590D\u5085\u4ED8\u961C\u7236\u8179\u8D1F\u5BCC\u8BA3\u9644\u5987\u7F1A\u5490\u5310\u51EB\u90DB\u8299\u82FB\u832F\u83A9\u83D4\u544B\u5E5E\u6ECF\u8274\u5B5A\u9A78\u7EC2\u6874\u8D59\u9EFB\u9EFC\u7F58\u7A03\u99A5\u864D\u86A8\u8709\u8760\u876E\u9EB8\u8DBA\u8DD7\u9CC6",
  ga: "\u5676\u560E\u86E4\u5C2C\u5477\u5C15\u5C1C\u65EE\u9486",
  gai: "\u8BE5\u6539\u6982\u9499\u76D6\u6E89\u4E10\u9654\u5793\u6224\u8D45\u80F2",
  gan: "\u5E72\u7518\u6746\u67D1\u7AFF\u809D\u8D76\u611F\u79C6\u6562\u8D63\u5769\u82F7\u5C34\u64C0\u6CD4\u6DE6\u6F89\u7EC0\u6A44\u65F0\u77F8\u75B3\u9150",
  gang: "\u5188\u521A\u94A2\u7F38\u809B\u7EB2\u5C97\u6E2F\u6206\u7F61\u9883\u7B7B",
  gong: "\u6760\u5DE5\u653B\u529F\u606D\u9F9A\u4F9B\u8EAC\u516C\u5BAB\u5F13\u5DE9\u6C5E\u62F1\u8D21\u5171\u857B\u5EFE\u54A3\u73D9\u80B1\u86A3\u86E9\u89E5",
  gao: "\u7BD9\u768B\u9AD8\u818F\u7F94\u7CD5\u641E\u9550\u7A3F\u544A\u777E\u8BF0\u90DC\u84BF\u85C1\u7F1F\u69D4\u69C1\u6772\u9506",
  ge: "\u54E5\u6B4C\u6401\u6208\u9E3D\u80F3\u7599\u5272\u9769\u845B\u683C\u9601\u9694\u94EC\u4E2A\u5404\u9B32\u4EE1\u54FF\u5865\u55DD\u7EA5\u643F\u8188\u784C\u94EA\u9549\u88BC\u988C\u867C\u8238\u9ABC\u9AC2",
  gei: "\u7ED9",
  gen: "\u6839\u8DDF\u4E98\u831B\u54CF\u826E",
  geng: "\u8015\u66F4\u5E9A\u7FB9\u57C2\u803F\u6897\u54FD\u8D53\u9CA0",
  gou: "\u94A9\u52FE\u6C9F\u82DF\u72D7\u57A2\u6784\u8D2D\u591F\u4F5D\u8BDF\u5CA3\u9058\u5ABE\u7F11\u89CF\u5F40\u9E32\u7B31\u7BDD\u97B2",
  gu: "\u8F9C\u83C7\u5495\u7B8D\u4F30\u6CBD\u5B64\u59D1\u9F13\u53E4\u86CA\u9AA8\u8C37\u80A1\u6545\u987E\u56FA\u96C7\u560F\u8BC2\u83F0\u54CC\u5D2E\u6C69\u688F\u8F71\u726F\u727F\u80CD\u81CC\u6BC2\u77BD\u7F5F\u94B4\u9522\u74E0\u9E2A\u9E44\u75FC\u86C4\u9164\u89DA\u9CB4\u9AB0\u9E58",
  gua: "\u522E\u74DC\u5250\u5BE1\u6302\u8902\u5366\u8BD6\u5471\u681D\u9E39",
  guai: "\u4E56\u62D0\u602A\u54D9",
  guan: "\u68FA\u5173\u5B98\u51A0\u89C2\u7BA1\u9986\u7F50\u60EF\u704C\u8D2F\u500C\u839E\u63BC\u6DAB\u76E5\u9E73\u9CCF",
  guang: "\u5149\u5E7F\u901B\u72B7\u6844\u80F1\u7592",
  gui: "\u7470\u89C4\u572D\u7845\u5F52\u9F9F\u95FA\u8F68\u9B3C\u8BE1\u7678\u6842\u67DC\u8DEA\u8D35\u523D\u5326\u523F\u5E8B\u5B84\u59AB\u6867\u7085\u6677\u7688\u7C0B\u9C91\u9CDC",
  gun: "\u8F8A\u6EDA\u68CD\u4E28\u886E\u7EF2\u78D9\u9CA7",
  guo: "\u9505\u90ED\u56FD\u679C\u88F9\u8FC7\u9998\u8803\u57DA\u63B4\u5459\u56D7\u5E3C\u5D1E\u7313\u6901\u8662\u951E\u8052\u872E\u873E\u8748",
  ha: "\u54C8",
  hai: "\u9AB8\u5B69\u6D77\u6C26\u4EA5\u5BB3\u9A87\u54B4\u55E8\u988F\u91A2",
  han: "\u9163\u61A8\u90AF\u97E9\u542B\u6DB5\u5BD2\u51FD\u558A\u7F55\u7FF0\u64BC\u634D\u65F1\u61BE\u608D\u710A\u6C57\u6C49\u9097\u83E1\u6496\u961A\u701A\u6657\u7113\u9894\u86B6\u9F3E",
  hen: "\u592F\u75D5\u5F88\u72E0\u6068",
  hang: "\u676D\u822A\u6C86\u7ED7\u73E9\u6841",
  hao: "\u58D5\u568E\u8C6A\u6BEB\u90DD\u597D\u8017\u53F7\u6D69\u8585\u55E5\u5686\u6FE0\u704F\u660A\u7693\u98A2\u869D",
  he: "\u5475\u559D\u8377\u83CF\u6838\u79BE\u548C\u4F55\u5408\u76D2\u8C89\u9602\u6CB3\u6DB8\u8D6B\u8910\u9E64\u8D3A\u8BC3\u52BE\u58D1\u85FF\u55D1\u55EC\u9616\u76CD\u86B5\u7FEE",
  hei: "\u563F\u9ED1",
  heng: "\u54FC\u4EA8\u6A2A\u8861\u6052\u8A07\u8605",
  hong: "\u8F70\u54C4\u70D8\u8679\u9E3F\u6D2A\u5B8F\u5F18\u7EA2\u9EC9\u8BA7\u836D\u85A8\u95F3\u6CD3",
  hou: "\u5589\u4FAF\u7334\u543C\u539A\u5019\u540E\u5820\u5F8C\u9005\u760A\u7BCC\u7CC7\u9C8E\u9ABA",
  hu: "\u547C\u4E4E\u5FFD\u745A\u58F6\u846B\u80E1\u8774\u72D0\u7CCA\u6E56\u5F27\u864E\u552C\u62A4\u4E92\u6CAA\u6237\u51B1\u553F\u56EB\u5CB5\u7322\u6019\u60DA\u6D52\u6EF9\u7425\u69F2\u8F77\u89F3\u70C0\u7173\u623D\u6248\u795C\u9E55\u9E71\u7B0F\u9190\u659B",
  hua: "\u82B1\u54D7\u534E\u733E\u6ED1\u753B\u5212\u5316\u8BDD\u5290\u6D4D\u9A85\u6866\u94E7\u7A1E",
  huai: "\u69D0\u5F8A\u6000\u6DEE\u574F\u8FD8\u8E1D",
  huan: "\u6B22\u73AF\u6853\u7F13\u6362\u60A3\u5524\u75EA\u8C62\u7115\u6DA3\u5BA6\u5E7B\u90C7\u5942\u57B8\u64D0\u571C\u6D39\u6D63\u6F36\u5BF0\u902D\u7F33\u953E\u9CA9\u9B1F",
  huang: "\u8352\u614C\u9EC4\u78FA\u8757\u7C27\u7687\u51F0\u60F6\u714C\u6643\u5E4C\u604D\u8C0E\u968D\u5FA8\u6E5F\u6F62\u9051\u749C\u8093\u7640\u87E5\u7BC1\u9CC7",
  hui: "\u7070\u6325\u8F89\u5FBD\u6062\u86D4\u56DE\u6BC1\u6094\u6167\u5349\u60E0\u6666\u8D3F\u79FD\u4F1A\u70E9\u6C47\u8BB3\u8BF2\u7ED8\u8BD9\u8334\u835F\u8559\u54D5\u5599\u96B3\u6D04\u5F57\u7F0B\u73F2\u6656\u605A\u867A\u87EA\u9EBE",
  hun: "\u8364\u660F\u5A5A\u9B42\u6D51\u6DF7\u8BE8\u9984\u960D\u6EB7\u7F17",
  huo: "\u8C41\u6D3B\u4F19\u706B\u83B7\u6216\u60D1\u970D\u8D27\u7978\u6509\u56AF\u5925\u94AC\u952A\u956C\u8020\u8816",
  ji: "\u51FB\u573E\u57FA\u673A\u7578\u7A3D\u79EF\u7B95\u808C\u9965\u8FF9\u6FC0\u8BA5\u9E21\u59EC\u7EE9\u7F09\u5409\u6781\u68D8\u8F91\u7C4D\u96C6\u53CA\u6025\u75BE\u6C72\u5373\u5AC9\u7EA7\u6324\u51E0\u810A\u5DF1\u84DF\u6280\u5180\u5B63\u4F0E\u796D\u5242\u60B8\u6D4E\u5BC4\u5BC2\u8BA1\u8BB0\u65E2\u5FCC\u9645\u5993\u7EE7\u7EAA\u5C45\u4E0C\u4E69\u525E\u4F76\u4F74\u8114\u58BC\u82A8\u82B0\u8401\u84BA\u857A\u638E\u53FD\u54AD\u54DC\u5527\u5C8C\u5D74\u6D0E\u5F50\u5C50\u9AA5\u757F\u7391\u696B\u6B9B\u621F\u6222\u8D4D\u89CA\u7284\u9F51\u77F6\u7F81\u5D47\u7A37\u7620\u7635\u866E\u7B08\u7B04\u66A8\u8DFB\u8DFD\u9701\u9C9A\u9CAB\u9AFB\u9E82",
  jia: "\u5609\u67B7\u5939\u4F73\u5BB6\u52A0\u835A\u988A\u8D3E\u7532\u94BE\u5047\u7A3C\u4EF7\u67B6\u9A7E\u5AC1\u4F3D\u90CF\u62EE\u5CAC\u6D43\u8FE6\u73C8\u621B\u80DB\u605D\u94D7\u9553\u75C2\u86F1\u7B33\u8888\u8DCF",
  jian: "\u6B7C\u76D1\u575A\u5C16\u7B3A\u95F4\u714E\u517C\u80A9\u8270\u5978\u7F04\u8327\u68C0\u67EC\u78B1\u7877\u62E3\u6361\u7B80\u4FED\u526A\u51CF\u8350\u69DB\u9274\u8DF5\u8D31\u89C1\u952E\u7BAD\u4EF6\u5065\u8230\u5251\u996F\u6E10\u6E85\u6DA7\u5EFA\u50ED\u8C0F\u8C2B\u83C5\u84B9\u641B\u56DD\u6E54\u8E47\u8B07\u7F23\u67A7\u67D9\u6957\u620B\u622C\u726E\u728D\u6BFD\u8171\u7751\u950F\u9E63\u88E5\u7B15\u7BB4\u7FE6\u8DBC\u8E3A\u9CA3\u97AF",
  jiang: "\u50F5\u59DC\u5C06\u6D46\u6C5F\u7586\u848B\u6868\u5956\u8BB2\u5320\u9171\u964D\u8333\u6D1A\u7EDB\u7F30\u729F\u7913\u8029\u7CE8\u8C47",
  jiao: "\u8549\u6912\u7901\u7126\u80F6\u4EA4\u90CA\u6D47\u9A84\u5A07\u56BC\u6405\u94F0\u77EB\u4FA5\u811A\u72E1\u89D2\u997A\u7F34\u7EDE\u527F\u6559\u9175\u8F7F\u8F83\u53EB\u4F7C\u50EC\u832D\u6322\u564D\u5CE4\u5FBC\u59E3\u7E9F\u656B\u768E\u9E6A\u86DF\u91AE\u8DE4\u9C9B",
  jie: "\u7A96\u63ED\u63A5\u7686\u79F8\u8857\u9636\u622A\u52AB\u8282\u6854\u6770\u6377\u776B\u7AED\u6D01\u7ED3\u89E3\u59D0\u6212\u85C9\u82A5\u754C\u501F\u4ECB\u75A5\u8BEB\u5C4A\u5048\u8BA6\u8BD8\u5588\u55DF\u736C\u5A55\u5B51\u6840\u7352\u78A3\u9534\u7596\u88B7\u9889\u86A7\u7FAF\u9C92\u9AB1\u9AEB",
  jin: "\u5DFE\u7B4B\u65A4\u91D1\u4ECA\u6D25\u895F\u7D27\u9526\u4EC5\u8C28\u8FDB\u9773\u664B\u7981\u8FD1\u70EC\u6D78\u5C3D\u537A\u8369\u5807\u5664\u9991\u5ED1\u5997\u7F19\u747E\u69FF\u8D46\u89D0\u9485\u9513\u887F\u77DC",
  jing: "\u52B2\u8346\u5162\u830E\u775B\u6676\u9CB8\u4EAC\u60CA\u7CBE\u7CB3\u7ECF\u4E95\u8B66\u666F\u9888\u9759\u5883\u656C\u955C\u5F84\u75C9\u9756\u7ADF\u7ADE\u51C0\u522D\u5106\u9631\u83C1\u734D\u61AC\u6CFE\u8FF3\u5F2A\u5A67\u80BC\u80EB\u8148\u65CC",
  jiong: "\u70AF\u7A98\u5182\u8FE5\u6243",
  jiu: "\u63EA\u7A76\u7EA0\u7396\u97ED\u4E45\u7078\u4E5D\u9152\u53A9\u6551\u65E7\u81FC\u8205\u548E\u5C31\u759A\u50E6\u557E\u9604\u67E9\u6855\u9E6B\u8D73\u9B0F",
  ju: "\u97A0\u62D8\u72D9\u75BD\u9A79\u83CA\u5C40\u5480\u77E9\u4E3E\u6CAE\u805A\u62D2\u636E\u5DE8\u5177\u8DDD\u8E1E\u952F\u4FF1\u53E5\u60E7\u70AC\u5267\u5028\u8BB5\u82E3\u82F4\u8392\u63AC\u907D\u5C66\u741A\u67B8\u6910\u6998\u6989\u6A58\u728B\u98D3\u949C\u9514\u7AAD\u88FE\u8D84\u91B5\u8E3D\u9F83\u96CE\u97AB",
  juan: "\u6350\u9E43\u5A1F\u5026\u7737\u5377\u7EE2\u9104\u72F7\u6D93\u684A\u8832\u9529\u954C\u96BD",
  jue: "\u6485\u652B\u6289\u6398\u5014\u7235\u89C9\u51B3\u8BC0\u7EDD\u53A5\u5282\u8C32\u77CD\u8568\u5658\u5D1B\u7357\u5B53\u73CF\u6877\u6A5B\u721D\u9562\u8E76\u89D6",
  jun: "\u5747\u83CC\u94A7\u519B\u541B\u5CFB\u4FCA\u7AE3\u6D5A\u90E1\u9A8F\u6343\u72FB\u76B2\u7B60\u9E87",
  ka: "\u5580\u5496\u5361\u4F67\u5494\u80E9",
  ke: "\u54AF\u5777\u82DB\u67EF\u68F5\u78D5\u9897\u79D1\u58F3\u54B3\u53EF\u6E34\u514B\u523B\u5BA2\u8BFE\u5CA2\u606A\u6E98\u9A92\u7F02\u73C2\u8F72\u6C2A\u778C\u94B6\u75B4\u7AA0\u874C\u9AC1",
  kai: "\u5F00\u63E9\u6977\u51EF\u6168\u5240\u57B2\u8488\u5FFE\u607A\u94E0\u950E",
  kan: "\u520A\u582A\u52D8\u574E\u780D\u770B\u4F83\u51F5\u83B0\u83B6\u6221\u9F9B\u77B0",
  kang: "\u5EB7\u6177\u7CE0\u625B\u6297\u4EA2\u7095\u5751\u4F09\u95F6\u94AA",
  kao: "\u8003\u62F7\u70E4\u9760\u5C3B\u6832\u7292\u94D0",
  ken: "\u80AF\u5543\u57A6\u6073\u57A0\u88C9\u9880",
  keng: "\u542D\u5FD0\u94FF",
  kong: "\u7A7A\u6050\u5B54\u63A7\u5025\u5D06\u7B9C",
  kou: "\u62A0\u53E3\u6263\u5BC7\u82A4\u853B\u53E9\u770D\u7B58",
  ku: "\u67AF\u54ED\u7A9F\u82E6\u9177\u5E93\u88E4\u5233\u5800\u55BE\u7ED4\u9AB7",
  kua: "\u5938\u57AE\u630E\u8DE8\u80EF\u4F89",
  kuai: "\u5757\u7B77\u4FA9\u5FEB\u84AF\u90D0\u8489\u72EF\u810D",
  kuan: "\u5BBD\u6B3E\u9ACB",
  kuang: "\u5321\u7B50\u72C2\u6846\u77FF\u7736\u65F7\u51B5\u8BD3\u8BF3\u909D\u5739\u593C\u54D0\u7EA9\u8D36",
  kui: "\u4E8F\u76D4\u5CBF\u7AA5\u8475\u594E\u9B41\u5080\u9988\u6127\u6E83\u9997\u532E\u5914\u9697\u63C6\u55B9\u559F\u609D\u6126\u9615\u9035\u668C\u777D\u8069\u8770\u7BD1\u81FE\u8DEC",
  kun: "\u5764\u6606\u6346\u56F0\u6083\u9603\u7428\u951F\u918C\u9CB2\u9AE1",
  kuo: "\u62EC\u6269\u5ED3\u9614\u86DE",
  la: "\u5783\u62C9\u5587\u8721\u814A\u8FA3\u5566\u524C\u647A\u908B\u65EF\u782C\u760C",
  lai: "\u83B1\u6765\u8D56\u5D03\u5F95\u6D9E\u6FD1\u8D49\u7750\u94FC\u765E\u7C41",
  lan: "\u84DD\u5A6A\u680F\u62E6\u7BEE\u9611\u5170\u6F9C\u8C30\u63FD\u89C8\u61D2\u7F06\u70C2\u6EE5\u5549\u5C9A\u61D4\u6F24\u6984\u6593\u7F71\u9567\u8934",
  lang: "\u7405\u6994\u72FC\u5ECA\u90CE\u6717\u6D6A\u83A8\u8497\u5577\u9606\u9512\u7A02\u8782",
  lao: "\u635E\u52B3\u7262\u8001\u4F6C\u59E5\u916A\u70D9\u6D9D\u5520\u5D02\u6833\u94D1\u94F9\u75E8\u91AA",
  le: "\u52D2\u4E50\u808B\u4EC2\u53FB\u561E\u6CD0\u9CD3",
  lei: "\u96F7\u956D\u857E\u78CA\u7D2F\u5121\u5792\u64C2\u7C7B\u6CEA\u7FB8\u8BD4\u837D\u54A7\u6F2F\u5AD8\u7F27\u6A91\u8012\u9179",
  ling: "\u68F1\u51B7\u62CE\u73B2\u83F1\u96F6\u9F84\u94C3\u4F36\u7F9A\u51CC\u7075\u9675\u5CAD\u9886\u53E6\u4EE4\u9143\u5844\u82D3\u5464\u56F9\u6CE0\u7EEB\u67C3\u68C2\u74F4\u8046\u86C9\u7FCE\u9CAE",
  leng: "\u695E\u6123",
  li: "\u5398\u68A8\u7281\u9ECE\u7BF1\u72F8\u79BB\u6F13\u7406\u674E\u91CC\u9CA4\u793C\u8389\u8354\u540F\u6817\u4E3D\u5389\u52B1\u783E\u5386\u5229\u5088\u4F8B\u4FD0\u75E2\u7ACB\u7C92\u6CA5\u96B6\u529B\u7483\u54E9\u4FEA\u4FDA\u90E6\u575C\u82C8\u8385\u84E0\u85DC\u6369\u5456\u5533\u55B1\u7301\u6EA7\u6FA7\u9026\u5A0C\u5AE0\u9A8A\u7F21\u73DE\u67A5\u680E\u8F79\u623E\u783A\u8A48\u7F79\u9502\u9E42\u75A0\u75AC\u86CE\u870A\u8821\u7B20\u7BE5\u7C9D\u91B4\u8DDE\u96F3\u9CA1\u9CE2\u9EE7",
  lian: "\u4FE9\u8054\u83B2\u8FDE\u9570\u5EC9\u601C\u6D9F\u5E18\u655B\u8138\u94FE\u604B\u70BC\u7EC3\u631B\u8539\u5941\u6F4B\u6FC2\u5A08\u740F\u695D\u6B93\u81C1\u81A6\u88E2\u880A\u9CA2",
  liang: "\u7CAE\u51C9\u6881\u7CB1\u826F\u4E24\u8F86\u91CF\u667E\u4EAE\u8C05\u589A\u690B\u8E09\u9753\u9B49",
  liao: "\u64A9\u804A\u50DA\u7597\u71CE\u5BE5\u8FBD\u6F66\u4E86\u6482\u9563\u5ED6\u6599\u84FC\u5C25\u5639\u7360\u5BEE\u7F2D\u948C\u9E69\u8022",
  lie: "\u5217\u88C2\u70C8\u52A3\u730E\u51BD\u57D2\u6D0C\u8D94\u8E90\u9B23",
  lin: "\u7433\u6797\u78F7\u9716\u4E34\u90BB\u9CDE\u6DCB\u51DB\u8D41\u541D\u853A\u5D99\u5EEA\u9074\u6AA9\u8F9A\u77B5\u7CBC\u8E8F\u9E9F",
  liu: "\u6E9C\u7409\u69B4\u786B\u998F\u7559\u5218\u7624\u6D41\u67F3\u516D\u62A1\u507B\u848C\u6CD6\u6D4F\u905B\u9A9D\u7EFA\u65D2\u7198\u950D\u954F\u9E68\u938F",
  long: "\u9F99\u804B\u5499\u7B3C\u7ABF\u9686\u5784\u62E2\u9647\u5F04\u5785\u830F\u6CF7\u73D1\u680A\u80E7\u783B\u7643",
  lou: "\u697C\u5A04\u6402\u7BD3\u6F0F\u964B\u55BD\u5D5D\u9542\u7618\u8027\u877C\u9AC5",
  lu: "\u82A6\u5362\u9885\u5E90\u7089\u63B3\u5364\u864F\u9C81\u9E93\u788C\u9732\u8DEF\u8D42\u9E7F\u6F5E\u7984\u5F55\u9646\u622E\u5786\u6445\u64B8\u565C\u6CF8\u6E0C\u6F09\u7490\u680C\u6A79\u8F73\u8F82\u8F98\u6C07\u80EA\u9565\u9E2C\u9E6D\u7C0F\u823B\u9C88",
  lv: "\u9A74\u5415\u94DD\u4FA3\u65C5\u5C65\u5C61\u7F15\u8651\u6C2F\u5F8B\u7387\u6EE4\u7EFF\u634B\u95FE\u6988\u8182\u7A06\u891B",
  luan: "\u5CE6\u5B6A\u6EE6\u5375\u4E71\u683E\u9E3E\u92AE",
  lue: "\u63A0\u7565\u950A",
  lun: "\u8F6E\u4F26\u4ED1\u6CA6\u7EB6\u8BBA\u56F5",
  luo: "\u841D\u87BA\u7F57\u903B\u9523\u7BA9\u9AA1\u88F8\u843D\u6D1B\u9A86\u7EDC\u502E\u8366\u645E\u7321\u6CFA\u6924\u8136\u9559\u7630\u96D2",
  ma: "\u5988\u9EBB\u739B\u7801\u8682\u9A6C\u9A82\u561B\u5417\u551B\u72B8\u5B37\u6769\u9EBD",
  mai: "\u57CB\u4E70\u9EA6\u5356\u8FC8\u8109\u52A2\u836C\u54AA\u973E",
  man: "\u7792\u9992\u86EE\u6EE1\u8513\u66FC\u6162\u6F2B\u8C29\u5881\u5E54\u7F26\u71B3\u9558\u989F\u87A8\u9CD7\u9794",
  mang: "\u8292\u832B\u76F2\u5FD9\u83BD\u9099\u6F2D\u6726\u786D\u87D2",
  meng: "\u6C13\u840C\u8499\u6AAC\u76DF\u9530\u731B\u68A6\u5B5F\u52D0\u750D\u77A2\u61F5\u791E\u867B\u8722\u8813\u824B\u8268\u9EFE",
  miao: "\u732B\u82D7\u63CF\u7784\u85D0\u79D2\u6E3A\u5E99\u5999\u55B5\u9088\u7F08\u7F2A\u676A\u6DFC\u7707\u9E4B\u8731",
  mao: "\u8305\u951A\u6BDB\u77DB\u94C6\u536F\u8302\u5192\u5E3D\u8C8C\u8D38\u4F94\u88A4\u52D6\u8306\u5CC1\u7441\u6634\u7266\u8004\u65C4\u61CB\u7780\u86D1\u8765\u87CA\u9AE6",
  me: "\u4E48",
  mei: "\u73AB\u679A\u6885\u9176\u9709\u7164\u6CA1\u7709\u5A92\u9541\u6BCF\u7F8E\u6627\u5BD0\u59B9\u5A9A\u5776\u8393\u5D4B\u7338\u6D7C\u6E44\u6963\u9545\u9E5B\u8882\u9B45",
  men: "\u95E8\u95F7\u4EEC\u626A\u739F\u7116\u61D1\u9494",
  mi: "\u772F\u919A\u9761\u7CDC\u8FF7\u8C1C\u5F25\u7C73\u79D8\u89C5\u6CCC\u871C\u5BC6\u5E42\u8288\u5196\u8C27\u863C\u5627\u7315\u736F\u6C68\u5B93\u5F2D\u8112\u6549\u7CF8\u7E3B\u9E8B",
  mian: "\u68C9\u7720\u7EF5\u5195\u514D\u52C9\u5A29\u7F05\u9762\u6C94\u6E4E\u817C\u7704",
  mie: "\u8511\u706D\u54A9\u881B\u7BFE",
  min: "\u6C11\u62BF\u76BF\u654F\u60AF\u95FD\u82E0\u5CB7\u95F5\u6CEF\u73C9",
  ming: "\u660E\u879F\u9E23\u94ED\u540D\u547D\u51A5\u8317\u6E9F\u669D\u7791\u9169",
  miu: "\u8C2C",
  mo: "\u6478\u6479\u8611\u6A21\u819C\u78E8\u6469\u9B54\u62B9\u672B\u83AB\u58A8\u9ED8\u6CAB\u6F20\u5BDE\u964C\u8C1F\u8309\u84E6\u998D\u5AEB\u9546\u79E3\u763C\u8031\u87C6\u8C8A\u8C98",
  mou: "\u8C0B\u725F\u67D0\u53B6\u54DE\u5A7A\u7738\u936A",
  mu: "\u62C7\u7261\u4EA9\u59C6\u6BCD\u5893\u66AE\u5E55\u52DF\u6155\u6728\u76EE\u7766\u7267\u7A46\u4EEB\u82DC\u5452\u6C90\u6BEA\u94BC",
  na: "\u62FF\u54EA\u5450\u94A0\u90A3\u5A1C\u7EB3\u5185\u637A\u80AD\u954E\u8872\u7BAC",
  nai: "\u6C16\u4E43\u5976\u8010\u5948\u9F10\u827F\u8418\u67F0",
  nan: "\u5357\u7537\u96BE\u56CA\u5583\u56E1\u6960\u8169\u877B\u8D67",
  nao: "\u6320\u8111\u607C\u95F9\u5B6C\u57B4\u7331\u7459\u7847\u94D9\u86F2",
  ne: "\u6DD6\u5462\u8BB7",
  nei: "\u9981",
  nen: "\u5AE9\u80FD\u6798\u6041",
  ni: "\u59AE\u9713\u502A\u6CE5\u5C3C\u62DF\u4F60\u533F\u817B\u9006\u6EBA\u4F32\u576D\u730A\u6029\u6EE0\u6635\u65CE\u7962\u615D\u7768\u94CC\u9CB5",
  nian: "\u852B\u62C8\u5E74\u78BE\u64B5\u637B\u5FF5\u5EFF\u8F87\u9ECF\u9C87\u9CB6",
  niang: "\u5A18\u917F",
  niao: "\u9E1F\u5C3F\u8311\u5B32\u8132\u8885",
  nie: "\u634F\u8042\u5B7D\u556E\u954A\u954D\u6D85\u4E5C\u9667\u8616\u55EB\u8080\u989E\u81EC\u8E51",
  nin: "\u60A8\u67E0",
  ning: "\u72DE\u51DD\u5B81\u62E7\u6CDE\u4F5E\u84E5\u549B\u752F\u804D",
  niu: "\u725B\u626D\u94AE\u7EBD\u72C3\u5FF8\u599E\u86B4",
  nong: "\u8113\u6D53\u519C\u4FAC",
  nu: "\u5974\u52AA\u6012\u5476\u5E11\u5F29\u80EC\u5B65\u9A7D",
  nv: "\u5973\u6067\u9495\u8844",
  nuan: "\u6696",
  nuenue: "\u8650",
  nue: "\u759F\u8C11",
  nuo: "\u632A\u61E6\u7CEF\u8BFA\u50A9\u6426\u558F\u9518",
  ou: "\u54E6\u6B27\u9E25\u6BB4\u85D5\u5455\u5076\u6CA4\u6004\u74EF\u8026",
  pa: "\u556A\u8DB4\u722C\u5E15\u6015\u7436\u8469\u7B62",
  pai: "\u62CD\u6392\u724C\u5F98\u6E43\u6D3E\u4FF3\u848E",
  pan: "\u6500\u6F58\u76D8\u78D0\u76FC\u7554\u5224\u53DB\u723F\u6CEE\u88A2\u897B\u87E0\u8E52",
  pang: "\u4E53\u5E9E\u65C1\u802A\u80D6\u6EC2\u9004",
  pao: "\u629B\u5486\u5228\u70AE\u888D\u8DD1\u6CE1\u530F\u72CD\u5E96\u812C\u75B1",
  pei: "\u5478\u80DA\u57F9\u88F4\u8D54\u966A\u914D\u4F69\u6C9B\u638A\u8F94\u5E14\u6DE0\u65C6\u952B\u9185\u9708",
  pen: "\u55B7\u76C6\u6E53",
  peng: "\u7830\u62A8\u70F9\u6F8E\u5F6D\u84EC\u68DA\u787C\u7BF7\u81A8\u670B\u9E4F\u6367\u78B0\u576F\u580B\u562D\u6026\u87DB",
  pi: "\u7812\u9739\u6279\u62AB\u5288\u7435\u6BD7\u5564\u813E\u75B2\u76AE\u5339\u75DE\u50FB\u5C41\u8B6C\u4E15\u9674\u90B3\u90EB\u572E\u9F19\u64D7\u567C\u5E80\u5AB2\u7EB0\u6787\u7513\u7765\u7F74\u94CD\u75E6\u7656\u758B\u868D\u8C94",
  pian: "\u7BC7\u504F\u7247\u9A97\u8C1D\u9A88\u728F\u80FC\u890A\u7FE9\u8E41",
  piao: "\u98D8\u6F02\u74E2\u7968\u527D\u560C\u5AD6\u7F25\u6B8D\u779F\u87B5",
  pie: "\u6487\u77A5\u4E3F\u82E4\u6C15",
  pin: "\u62FC\u9891\u8D2B\u54C1\u8058\u62DA\u59D8\u5AD4\u6980\u725D\u98A6",
  ping: "\u4E52\u576A\u82F9\u840D\u5E73\u51ED\u74F6\u8BC4\u5C4F\u4FDC\u5A09\u67B0\u9C86",
  po: "\u5761\u6CFC\u9887\u5A46\u7834\u9B44\u8FEB\u7C95\u53F5\u9131\u6EA5\u73C0\u948B\u94B7\u76A4\u7B38",
  pou: "\u5256\u88D2\u8E23",
  pu: "\u6251\u94FA\u4EC6\u8386\u8461\u83E9\u84B2\u57D4\u6734\u5703\u666E\u6D66\u8C31\u66DD\u7011\u530D\u5657\u6FEE\u749E\u6C06\u9564\u9568\u8E7C",
  qi: "\u671F\u6B3A\u6816\u621A\u59BB\u4E03\u51C4\u6F06\u67D2\u6C8F\u5176\u68CB\u5947\u6B67\u7566\u5D0E\u8110\u9F50\u65D7\u7948\u7941\u9A91\u8D77\u5C82\u4E5E\u4F01\u542F\u5951\u780C\u5668\u6C14\u8FC4\u5F03\u6C7D\u6CE3\u8BAB\u4E9F\u4E93\u573B\u8291\u840B\u847A\u5601\u5C7A\u5C90\u6C54\u6DC7\u9A90\u7EEE\u742A\u7426\u675E\u6864\u69ED\u6B39\u797A\u61A9\u789B\u86F4\u871E\u7DA6\u7DAE\u8DBF\u8E4A\u9CCD\u9E92",
  qia: "\u6390\u6070\u6D3D\u845C",
  qian: "\u7275\u6266\u948E\u94C5\u5343\u8FC1\u7B7E\u4EDF\u8C26\u4E7E\u9ED4\u94B1\u94B3\u524D\u6F5C\u9063\u6D45\u8C34\u5811\u5D4C\u6B20\u6B49\u4F65\u9621\u828A\u82A1\u8368\u63AE\u5C8D\u60AD\u614A\u9A9E\u6434\u8930\u7F31\u6920\u80B7\u6106\u94A4\u8654\u7B9D",
  qiang: "\u67AA\u545B\u8154\u7F8C\u5899\u8537\u5F3A\u62A2\u5AF1\u6A2F\u6217\u709D\u9516\u9535\u956A\u8941\u8723\u7F9F\u8DEB\u8DC4",
  qiao: "\u6A47\u9539\u6572\u6084\u6865\u77A7\u4E54\u4FA8\u5DE7\u9798\u64AC\u7FD8\u5CED\u4FCF\u7A8D\u5281\u8BEE\u8C2F\u835E\u6100\u6194\u7F32\u6A35\u6BF3\u7857\u8DF7\u9792",
  qie: "\u5207\u8304\u4E14\u602F\u7A83\u90C4\u553C\u60EC\u59BE\u6308\u9532\u7BA7",
  qin: "\u94A6\u4FB5\u4EB2\u79E6\u7434\u52E4\u82B9\u64D2\u79BD\u5BDD\u6C81\u82A9\u84C1\u8572\u63FF\u5423\u55EA\u5659\u6EB1\u6A8E\u8793\u887E",
  qing: "\u9752\u8F7B\u6C22\u503E\u537F\u6E05\u64CE\u6674\u6C30\u60C5\u9877\u8BF7\u5E86\u5029\u82D8\u570A\u6AA0\u78EC\u873B\u7F44\u7B90\u8B26\u9CAD\u9EE5",
  qiong: "\u743C\u7A77\u909B\u8315\u7A79\u7B47\u928E",
  qiu: "\u79CB\u4E18\u90B1\u7403\u6C42\u56DA\u914B\u6CC5\u4FC5\u6C3D\u5DEF\u827D\u72B0\u6E6B\u9011\u9052\u6978\u8D47\u9E20\u866C\u86AF\u8764\u88D8\u7CD7\u9CC5\u9F3D",
  qu: "\u8D8B\u533A\u86C6\u66F2\u8EAF\u5C48\u9A71\u6E20\u53D6\u5A36\u9F8B\u8DA3\u53BB\u8BCE\u52AC\u8556\u8627\u5C96\u8862\u9612\u74A9\u89D1\u6C0D\u795B\u78F2\u766F\u86D0\u883C\u9EB4\u77BF\u9EE2",
  quan: "\u5708\u98A7\u6743\u919B\u6CC9\u5168\u75CA\u62F3\u72AC\u5238\u529D\u8BE0\u8343\u737E\u609B\u7EFB\u8F81\u754E\u94E8\u8737\u7B4C\u9B08",
  que: "\u7F3A\u7094\u7638\u5374\u9E4A\u69B7\u786E\u96C0\u9619\u60AB",
  qun: "\u88D9\u7FA4\u9021",
  ran: "\u7136\u71C3\u5189\u67D3\u82D2\u9AEF",
  rang: "\u74E4\u58E4\u6518\u56B7\u8BA9\u79B3\u7A70",
  rao: "\u9976\u6270\u7ED5\u835B\u5A06\u6861",
  ruo: "\u60F9\u82E5\u5F31",
  re: "\u70ED\u504C",
  ren: "\u58EC\u4EC1\u4EBA\u5FCD\u97E7\u4EFB\u8BA4\u5203\u598A\u7EAB\u4EDE\u834F\u845A\u996A\u8F6B\u7A14\u887D",
  reng: "\u6254\u4ECD",
  ri: "\u65E5",
  rong: "\u620E\u8338\u84C9\u8363\u878D\u7194\u6EB6\u5BB9\u7ED2\u5197\u5D58\u72E8\u7F1B\u6995\u877E",
  rou: "\u63C9\u67D4\u8089\u7CC5\u8E42\u97A3",
  ru: "\u8339\u8815\u5112\u5B7A\u5982\u8FB1\u4E73\u6C5D\u5165\u8925\u84D0\u85B7\u5685\u6D33\u6EBD\u6FE1\u94F7\u8966\u98A5",
  ruan: "\u8F6F\u962E\u670A",
  rui: "\u854A\u745E\u9510\u82AE\u8564\u777F\u868B",
  run: "\u95F0\u6DA6",
  sa: "\u6492\u6D12\u8428\u5345\u4EE8\u6332\u98D2",
  sai: "\u816E\u9CC3\u585E\u8D5B\u567B",
  san: "\u4E09\u53C1\u4F1E\u6563\u5F61\u9993\u6C35\u6BF5\u7CC1\u9730",
  sang: "\u6851\u55D3\u4E27\u6421\u78C9\u98A1",
  sao: "\u6414\u9A9A\u626B\u5AC2\u57FD\u81CA\u7619\u9CCB",
  se: "\u745F\u8272\u6DA9\u556C\u94E9\u94EF\u7A51",
  sen: "\u68EE",
  seng: "\u50E7",
  sha: "\u838E\u7802\u6740\u5239\u6C99\u7EB1\u50BB\u5565\u715E\u810E\u6B43\u75E7\u88DF\u970E\u9CA8",
  shai: "\u7B5B\u6652\u917E",
  shan: "\u73CA\u82EB\u6749\u5C71\u5220\u717D\u886B\u95EA\u9655\u64C5\u8D61\u81B3\u5584\u6C55\u6247\u7F2E\u5261\u8BAA\u912F\u57CF\u829F\u6F78\u59D7\u9A9F\u81BB\u9490\u759D\u87EE\u8222\u8DDA\u9CDD",
  shang: "\u5892\u4F24\u5546\u8D4F\u664C\u4E0A\u5C1A\u88F3\u57A7\u7EF1\u6B87\u71B5\u89DE",
  shao: "\u68A2\u634E\u7A0D\u70E7\u828D\u52FA\u97F6\u5C11\u54E8\u90B5\u7ECD\u52AD\u82D5\u6F72\u86F8\u7B24\u7B72\u8244",
  she: "\u5962\u8D4A\u86C7\u820C\u820D\u8D66\u6444\u5C04\u6151\u6D89\u793E\u8BBE\u538D\u4F58\u731E\u7572\u9E9D",
  shen: "\u7837\u7533\u547B\u4F38\u8EAB\u6DF1\u5A20\u7EC5\u795E\u6C88\u5BA1\u5A76\u751A\u80BE\u614E\u6E17\u8BDC\u8C02\u5432\u54C2\u6E16\u6939\u77E7\u8703",
  sheng: "\u58F0\u751F\u7525\u7272\u5347\u7EF3\u7701\u76DB\u5269\u80DC\u5723\u4E1E\u6E11\u5AB5\u771A\u7B19",
  shi: "\u5E08\u5931\u72EE\u65BD\u6E7F\u8BD7\u5C38\u8671\u5341\u77F3\u62FE\u65F6\u4EC0\u98DF\u8680\u5B9E\u8BC6\u53F2\u77E2\u4F7F\u5C4E\u9A76\u59CB\u5F0F\u793A\u58EB\u4E16\u67FF\u4E8B\u62ED\u8A93\u901D\u52BF\u662F\u55DC\u566C\u9002\u4ED5\u4F8D\u91CA\u9970\u6C0F\u5E02\u6043\u5BA4\u89C6\u8BD5\u8C25\u57D8\u83B3\u84CD\u5F11\u5511\u9963\u8F7C\u8006\u8D33\u70BB\u793B\u94C8\u94CA\u87AB\u8210\u7B6E\u8C55\u9CA5\u9CBA",
  shou: "\u6536\u624B\u9996\u5B88\u5BFF\u6388\u552E\u53D7\u7626\u517D\u624C\u72E9\u7EF6\u824F",
  shu: "\u852C\u67A2\u68B3\u6B8A\u6292\u8F93\u53D4\u8212\u6DD1\u758F\u4E66\u8D4E\u5B70\u719F\u85AF\u6691\u66D9\u7F72\u8700\u9ECD\u9F20\u5C5E\u672F\u8FF0\u6811\u675F\u620D\u7AD6\u5885\u5EB6\u6570\u6F31\u6055\u500F\u587E\u83FD\u5FC4\u6CAD\u6D91\u6F8D\u59DD\u7EBE\u6BF9\u8167\u6BB3\u956F\u79EB\u9E6C",
  shua: "\u5237\u800D\u5530\u6DAE",
  shuai: "\u6454\u8870\u7529\u5E05\u87C0",
  shuan: "\u6813\u62F4\u95E9",
  shuang: "\u971C\u53CC\u723D\u5B40",
  shui: "\u8C01\u6C34\u7761\u7A0E",
  shun: "\u542E\u77AC\u987A\u821C\u6042",
  shuo: "\u8BF4\u7855\u6714\u70C1\u84B4\u6420\u55CD\u6FEF\u5981\u69CA\u94C4",
  si: "\u65AF\u6495\u5636\u601D\u79C1\u53F8\u4E1D\u6B7B\u8086\u5BFA\u55E3\u56DB\u4F3A\u4F3C\u9972\u5DF3\u53AE\u4FDF\u5155\u83E5\u549D\u6C5C\u6CD7\u6F8C\u59D2\u9A77\u7F0C\u7940\u7960\u9536\u9E36\u801C\u86F3\u7B25",
  song: "\u677E\u8038\u6002\u9882\u9001\u5B8B\u8BBC\u8BF5\u51C7\u83D8\u5D27\u5D69\u5FEA\u609A\u6DDE\u7AE6",
  sou: "\u641C\u8258\u64DE\u55FD\u53DF\u55D6\u55FE\u998A\u6EB2\u98D5\u778D\u953C\u878B",
  su: "\u82CF\u9165\u4FD7\u7D20\u901F\u7C9F\u50F3\u5851\u6EAF\u5BBF\u8BC9\u8083\u5919\u8C21\u850C\u55C9\u612B\u7C0C\u89EB\u7A23",
  suan: "\u9178\u849C\u7B97",
  sui: "\u867D\u968B\u968F\u7EE5\u9AD3\u788E\u5C81\u7A57\u9042\u96A7\u795F\u84D1\u51AB\u8C07\u6FC9\u9083\u71E7\u772D\u7762",
  sun: "\u5B59\u635F\u7B0B\u836A\u72F2\u98E7\u69AB\u8DE3\u96BC",
  suo: "\u68AD\u5506\u7F29\u7410\u7D22\u9501\u6240\u5522\u55E6\u5A11\u686B\u7743\u7FA7",
  ta: "\u584C\u4ED6\u5B83\u5979\u5854\u736D\u631E\u8E4B\u8E0F\u95FC\u6EBB\u9062\u69BB\u6C93",
  tai: "\u80CE\u82D4\u62AC\u53F0\u6CF0\u915E\u592A\u6001\u6C70\u90B0\u85B9\u80BD\u70B1\u949B\u8DC6\u9C90",
  tan: "\u574D\u644A\u8D2A\u762B\u6EE9\u575B\u6A80\u75F0\u6F6D\u8C2D\u8C08\u5766\u6BEF\u8892\u78B3\u63A2\u53F9\u70AD\u90EF\u8548\u6619\u94BD\u952C\u8983",
  tang: "\u6C64\u5858\u642A\u5802\u68E0\u819B\u5510\u7CD6\u50A5\u9967\u6E8F\u746D\u94F4\u9557\u8025\u8797\u87B3\u7FB0\u91A3",
  thang: "\u5018\u8EBA\u6DCC",
  theng: "\u8D9F\u70EB",
  tao: "\u638F\u6D9B\u6ED4\u7EE6\u8404\u6843\u9003\u6DD8\u9676\u8BA8\u5957\u6311\u9F17\u5555\u97EC\u9955",
  te: "\u7279",
  teng: "\u85E4\u817E\u75BC\u8A8A\u6ED5",
  ti: "\u68AF\u5254\u8E22\u9511\u63D0\u9898\u8E44\u557C\u4F53\u66FF\u568F\u60D5\u6D95\u5243\u5C49\u8351\u608C\u9016\u7EE8\u7F07\u9E48\u88FC\u918D",
  tian: "\u5929\u6DFB\u586B\u7530\u751C\u606C\u8214\u8146\u63AD\u5FDD\u9617\u6B84\u754B\u94BF\u86BA",
  tiao: "\u6761\u8FE2\u773A\u8DF3\u4F7B\u7967\u94EB\u7A95\u9F86\u9CA6",
  tie: "\u8D34\u94C1\u5E16\u841C\u992E",
  ting: "\u5385\u542C\u70C3\u6C40\u5EF7\u505C\u4EAD\u5EAD\u633A\u8247\u839B\u8476\u5A77\u6883\u8713\u9706",
  tong: "\u901A\u6850\u916E\u77B3\u540C\u94DC\u5F64\u7AE5\u6876\u6345\u7B52\u7EDF\u75DB\u4F5F\u50EE\u4EDD\u833C\u55F5\u6078\u6F7C\u783C",
  tou: "\u5077\u6295\u5934\u900F\u4EA0",
  tu: "\u51F8\u79C3\u7A81\u56FE\u5F92\u9014\u6D82\u5C60\u571F\u5410\u5154\u580D\u837C\u83DF\u948D\u9174",
  tuan: "\u6E4D\u56E2\u7583",
  tui: "\u63A8\u9893\u817F\u8715\u892A\u9000\u5FD2\u717A",
  tun: "\u541E\u5C6F\u81C0\u9968\u66BE\u8C5A\u7A80",
  tuo: "\u62D6\u6258\u8131\u9E35\u9640\u9A6E\u9A7C\u692D\u59A5\u62D3\u553E\u4E47\u4F57\u5768\u5EB9\u6CB1\u67DD\u7823\u7BA8\u8204\u8DCE\u9F0D",
  wa: "\u6316\u54C7\u86D9\u6D3C\u5A03\u74E6\u889C\u4F64\u5A32\u817D",
  wai: "\u6B6A\u5916",
  wan: "\u8C4C\u5F2F\u6E7E\u73A9\u987D\u4E38\u70F7\u5B8C\u7897\u633D\u665A\u7696\u60CB\u5B9B\u5A49\u4E07\u8155\u525C\u8284\u82CB\u83C0\u7EA8\u7EFE\u742C\u8118\u7579\u873F\u7BA2",
  wang: "\u6C6A\u738B\u4EA1\u6789\u7F51\u5F80\u65FA\u671B\u5FD8\u5984\u7F54\u5C22\u60D8\u8F8B\u9B4D",
  wei: "\u5A01\u5DCD\u5FAE\u5371\u97E6\u8FDD\u6845\u56F4\u552F\u60DF\u4E3A\u6F4D\u7EF4\u82C7\u840E\u59D4\u4F1F\u4F2A\u5C3E\u7EAC\u672A\u851A\u5473\u754F\u80C3\u5582\u9B4F\u4F4D\u6E2D\u8C13\u5C09\u6170\u536B\u502D\u504E\u8BFF\u9688\u8473\u8587\u5E0F\u5E37\u5D34\u5D6C\u7325\u732C\u95F1\u6CA9\u6D27\u6DA0\u9036\u5A13\u73AE\u97EA\u8ECE\u709C\u7168\u71A8\u75FF\u8249\u9C94",
  wen: "\u761F\u6E29\u868A\u6587\u95FB\u7EB9\u543B\u7A33\u7D0A\u95EE\u520E\u6120\u960C\u6C76\u74BA\u97EB\u6B81\u96EF",
  weng: "\u55E1\u7FC1\u74EE\u84CA\u8579",
  wo: "\u631D\u8717\u6DA1\u7A9D\u6211\u65A1\u5367\u63E1\u6C83\u83B4\u5E44\u6E25\u674C\u809F\u9F8C",
  wu: "\u5DEB\u545C\u94A8\u4E4C\u6C61\u8BEC\u5C4B\u65E0\u829C\u68A7\u543E\u5434\u6BCB\u6B66\u4E94\u6342\u5348\u821E\u4F0D\u4FAE\u575E\u620A\u96FE\u6664\u7269\u52FF\u52A1\u609F\u8BEF\u5140\u4EF5\u9622\u90AC\u572C\u82B4\u5E91\u6003\u5FE4\u6D6F\u5BE4\u8FD5\u59A9\u9A9B\u727E\u7110\u9E49\u9E5C\u8708\u92C8\u9F2F",
  xi: "\u6614\u7199\u6790\u897F\u7852\u77FD\u6670\u563B\u5438\u9521\u727A\u7A00\u606F\u5E0C\u6089\u819D\u5915\u60DC\u7184\u70EF\u6EAA\u6C50\u7280\u6A84\u88AD\u5E2D\u4E60\u5AB3\u559C\u94E3\u6D17\u7CFB\u9699\u620F\u7EC6\u50D6\u516E\u96B0\u90D7\u831C\u8478\u84F0\u595A\u550F\u5F99\u9969\u960B\u6D60\u6DC5\u5C63\u5B09\u73BA\u6A28\u66E6\u89CB\u6B37\u71B9\u798A\u79A7\u94B8\u7699\u7A78\u8725\u87CB\u823E\u7FB2\u7C9E\u7FD5\u91AF\u9F37",
  xia: "\u778E\u867E\u5323\u971E\u8F96\u6687\u5CE1\u4FA0\u72ED\u4E0B\u53A6\u590F\u5413\u6380\u846D\u55C4\u72CE\u9050\u7455\u7856\u7615\u7F45\u9EE0",
  xian: "\u9528\u5148\u4ED9\u9C9C\u7EA4\u54B8\u8D24\u8854\u8237\u95F2\u6D8E\u5F26\u5ACC\u663E\u9669\u73B0\u732E\u53BF\u817A\u9985\u7FA1\u5BAA\u9677\u9650\u7EBF\u51BC\u85D3\u5C98\u7303\u66B9\u5A34\u6C19\u7946\u9E47\u75EB\u86AC\u7B45\u7C7C\u9170\u8DF9",
  xiang: "\u76F8\u53A2\u9576\u9999\u7BB1\u8944\u6E58\u4E61\u7FD4\u7965\u8BE6\u60F3\u54CD\u4EAB\u9879\u5DF7\u6A61\u50CF\u5411\u8C61\u8297\u8459\u9977\u5EA0\u9AA7\u7F03\u87D3\u9C9E\u98E8",
  xiao: "\u8427\u785D\u9704\u524A\u54EE\u56A3\u9500\u6D88\u5BB5\u6DC6\u6653\u5C0F\u5B5D\u6821\u8096\u5578\u7B11\u6548\u54D3\u54BB\u5D24\u6F47\u900D\u9A81\u7EE1\u67AD\u67B5\u7B71\u7BAB\u9B48",
  xie: "\u6954\u4E9B\u6B47\u874E\u978B\u534F\u631F\u643A\u90AA\u659C\u80C1\u8C10\u5199\u68B0\u5378\u87F9\u61C8\u6CC4\u6CFB\u8C22\u5C51\u5055\u4EB5\u52F0\u71EE\u85A4\u64B7\u5EE8\u7023\u9082\u7EC1\u7F2C\u69AD\u698D\u6B59\u8E9E",
  xin: "\u85AA\u82AF\u950C\u6B23\u8F9B\u65B0\u5FFB\u5FC3\u4FE1\u8845\u56DF\u99A8\u8398\u6B46\u94FD\u946B",
  xing: "\u661F\u8165\u7329\u60FA\u5174\u5211\u578B\u5F62\u90A2\u884C\u9192\u5E78\u674F\u6027\u59D3\u9649\u8347\u8365\u64E4\u60BB\u784E",
  xiong: "\u5144\u51F6\u80F8\u5308\u6C79\u96C4\u718A\u828E",
  xiu: "\u4F11\u4FEE\u7F9E\u673D\u55C5\u9508\u79C0\u8896\u7EE3\u83A0\u5CAB\u9990\u5EA5\u9E3A\u8C85\u9AF9",
  xu: "\u589F\u620C\u9700\u865A\u5618\u987B\u5F90\u8BB8\u84C4\u9157\u53D9\u65ED\u5E8F\u755C\u6064\u7D6E\u5A7F\u7EEA\u7EED\u8BB4\u8BE9\u5729\u84FF\u6035\u6D2B\u6E86\u987C\u6829\u7166\u7809\u76F1\u80E5\u7CC8\u9191",
  xuan: "\u8F69\u55A7\u5BA3\u60AC\u65CB\u7384\u9009\u7663\u7729\u7EDA\u5107\u8C16\u8431\u63CE\u9994\u6CEB\u6D35\u6E32\u6F29\u7487\u6966\u6684\u70AB\u714A\u78B9\u94C9\u955F\u75C3",
  xue: "\u9774\u859B\u5B66\u7A74\u96EA\u8840\u5671\u6CF6\u9CD5",
  xun: "\u52CB\u718F\u5FAA\u65EC\u8BE2\u5BFB\u9A6F\u5DE1\u6B89\u6C5B\u8BAD\u8BAF\u900A\u8FC5\u5DFD\u57D9\u8340\u85B0\u5CCB\u5F87\u6D54\u66DB\u7AA8\u91BA\u9C9F",
  ya: "\u538B\u62BC\u9E26\u9E2D\u5440\u4E2B\u82BD\u7259\u869C\u5D16\u8859\u6DAF\u96C5\u54D1\u4E9A\u8BB6\u4F22\u63E0\u5416\u5C88\u8FD3\u5A05\u740A\u6860\u6C29\u7811\u775A\u75D6",
  yan: "\u7109\u54BD\u9609\u70DF\u6DF9\u76D0\u4E25\u7814\u8712\u5CA9\u5EF6\u8A00\u989C\u960E\u708E\u6CBF\u5944\u63A9\u773C\u884D\u6F14\u8273\u5830\u71D5\u538C\u781A\u96C1\u5501\u5F66\u7130\u5BB4\u8C1A\u9A8C\u53A3\u9765\u8D5D\u4FE8\u5043\u5156\u8BA0\u8C33\u90FE\u9122\u82AB\u83F8\u5D26\u6079\u95EB\u960F\u6D07\u6E6E\u6EDF\u598D\u5AE3\u7430\u664F\u80ED\u814C\u7131\u7F68\u7B75\u917D\u9B47\u990D\u9F39",
  yang: "\u6B83\u592E\u9E2F\u79E7\u6768\u626C\u4F6F\u75A1\u7F8A\u6D0B\u9633\u6C27\u4EF0\u75D2\u517B\u6837\u6F3E\u5F89\u600F\u6CF1\u7080\u70CA\u6059\u86D8\u9785",
  yao: "\u9080\u8170\u5996\u7476\u6447\u5C27\u9065\u7A91\u8C23\u59DA\u54AC\u8200\u836F\u8981\u8000\u592D\u723B\u5406\u5D3E\u5FAD\u7039\u5E7A\u73E7\u6773\u66DC\u80B4\u9E5E\u7A88\u7E47\u9CD0",
  ye: "\u6930\u564E\u8036\u7237\u91CE\u51B6\u4E5F\u9875\u6396\u4E1A\u53F6\u66F3\u814B\u591C\u6DB2\u8C12\u90BA\u63F6\u9980\u6654\u70E8\u94D8",
  yi: "\u4E00\u58F9\u533B\u63D6\u94F1\u4F9D\u4F0A\u8863\u9890\u5937\u9057\u79FB\u4EEA\u80F0\u7591\u6C82\u5B9C\u59E8\u5F5D\u6905\u8681\u501A\u5DF2\u4E59\u77E3\u4EE5\u827A\u6291\u6613\u9091\u5C79\u4EBF\u5F79\u81C6\u9038\u8084\u75AB\u4EA6\u88D4\u610F\u6BC5\u5FC6\u4E49\u76CA\u6EA2\u8BE3\u8BAE\u8C0A\u8BD1\u5F02\u7FFC\u7FCC\u7ECE\u5208\u5293\u4F7E\u8BD2\u572A\u572F\u57F8\u61FF\u82E1\u858F\u5F08\u5955\u6339\u5F0B\u5453\u54A6\u54BF\u566B\u5CC4\u5DB7\u7317\u9974\u603F\u6021\u6092\u6F2A\u8FE4\u9A7F\u7F22\u6BAA\u8D3B\u65D6\u71A0\u9487\u9552\u9571\u75CD\u7617\u7654\u7FCA\u8864\u8734\u8223\u7FBF\u7FF3\u914F\u9EDF",
  yin: "\u8335\u836B\u56E0\u6BB7\u97F3\u9634\u59FB\u541F\u94F6\u6DEB\u5BC5\u996E\u5C39\u5F15\u9690\u5370\u80E4\u911E\u5819\u831A\u5591\u72FA\u5924\u6C24\u94DF\u763E\u8693\u972A\u9F88",
  ying: "\u82F1\u6A31\u5A74\u9E70\u5E94\u7F28\u83B9\u8424\u8425\u8367\u8747\u8FCE\u8D62\u76C8\u5F71\u9896\u786C\u6620\u5B34\u90E2\u8314\u83BA\u8426\u6484\u5624\u81BA\u6EE2\u6F46\u701B\u745B\u748E\u6979\u9E66\u763F\u988D\u7F42",
  yo: "\u54DF\u5537",
  yong: "\u62E5\u4F63\u81C3\u75C8\u5EB8\u96CD\u8E0A\u86F9\u548F\u6CF3\u6D8C\u6C38\u607F\u52C7\u7528\u4FD1\u58C5\u5889\u6175\u9095\u955B\u752C\u9CD9\u9954",
  you: "\u5E7D\u4F18\u60A0\u5FE7\u5C24\u7531\u90AE\u94C0\u72B9\u6CB9\u6E38\u9149\u6709\u53CB\u53F3\u4F51\u91C9\u8BF1\u53C8\u5E7C\u5363\u6538\u4F91\u83B8\u5466\u56FF\u5BA5\u67DA\u7337\u7256\u94D5\u75A3\u8763\u9C7F\u9EDD\u9F2C",
  yu: "\u8FC2\u6DE4\u4E8E\u76C2\u6986\u865E\u611A\u8206\u4F59\u4FDE\u903E\u9C7C\u6109\u6E1D\u6E14\u9685\u4E88\u5A31\u96E8\u4E0E\u5C7F\u79B9\u5B87\u8BED\u7FBD\u7389\u57DF\u828B\u90C1\u5401\u9047\u55BB\u5CEA\u5FA1\u6108\u6B32\u72F1\u80B2\u8A89\u6D74\u5BD3\u88D5\u9884\u8C6B\u9A6D\u79BA\u6BD3\u4F1B\u4FE3\u8C00\u8C15\u8438\u84E3\u63C4\u5581\u5704\u5709\u5D5B\u72F3\u996B\u5EBE\u9608\u59AA\u59A4\u7EA1\u745C\u6631\u89CE\u8174\u6B24\u65BC\u715C\u71E0\u807F\u94B0\u9E46\u7610\u7600\u7AB3\u8753\u7AFD\u8201\u96E9\u9F89",
  yuan: "\u9E33\u6E0A\u51A4\u5143\u57A3\u8881\u539F\u63F4\u8F95\u56ED\u5458\u5706\u733F\u6E90\u7F18\u8FDC\u82D1\u613F\u6028\u9662\u586C\u6C85\u5A9B\u7457\u6A7C\u7230\u7722\u9E22\u8788\u9F0B",
  yue: "\u66F0\u7EA6\u8D8A\u8DC3\u94A5\u5CB3\u7CA4\u6708\u60A6\u9605\u9FA0\u6A3E\u5216\u94BA",
  yun: "\u8018\u4E91\u90E7\u5300\u9668\u5141\u8FD0\u8574\u915D\u6655\u97F5\u5B55\u90D3\u82B8\u72C1\u607D\u7EAD\u6B92\u6600\u6C32",
  za: "\u531D\u7838\u6742\u62F6\u5482",
  zai: "\u683D\u54C9\u707E\u5BB0\u8F7D\u518D\u5728\u54B1\u5D3D\u753E",
  zan: "\u6512\u6682\u8D5E\u74D2\u661D\u7C2A\u7CCC\u8DB1\u933E",
  zang: "\u8D43\u810F\u846C\u5958\u6215\u81E7",
  zao: "\u906D\u7CDF\u51FF\u85FB\u67A3\u65E9\u6FA1\u86A4\u8E81\u566A\u9020\u7682\u7076\u71E5\u5523\u7F2B",
  ze: "\u8D23\u62E9\u5219\u6CFD\u4EC4\u8D5C\u5567\u8FEE\u6603\u7B2E\u7BA6\u8234",
  zei: "\u8D3C",
  zen: "\u600E\u8C2E",
  zeng: "\u589E\u618E\u66FE\u8D60\u7F2F\u7511\u7F7E\u9503",
  zha: "\u624E\u55B3\u6E23\u672D\u8F67\u94E1\u95F8\u7728\u6805\u69A8\u548B\u4E4D\u70B8\u8BC8\u63F8\u5412\u54A4\u54F3\u600D\u781F\u75C4\u86B1\u9F44",
  zhai: "\u6458\u658B\u5B85\u7A84\u503A\u5BE8\u7826",
  zhan: "\u77BB\u6BE1\u8A79\u7C98\u6CBE\u76CF\u65A9\u8F97\u5D2D\u5C55\u8638\u6808\u5360\u6218\u7AD9\u6E5B\u7EFD\u8C35\u640C\u65C3",
  zhang: "\u6A1F\u7AE0\u5F70\u6F33\u5F20\u638C\u6DA8\u6756\u4E08\u5E10\u8D26\u4ED7\u80C0\u7634\u969C\u4EC9\u9123\u5E5B\u5D82\u7350\u5ADC\u748B\u87D1",
  zhao: "\u62DB\u662D\u627E\u6CBC\u8D75\u7167\u7F69\u5146\u8087\u53EC\u722A\u8BCF\u68F9\u948A\u7B0A",
  zhe: "\u906E\u6298\u54F2\u86F0\u8F99\u8005\u9517\u8517\u8FD9\u6D59\u8C2A\u966C\u67D8\u8F84\u78D4\u9E67\u891A\u8707\u8D6D",
  zhen: "\u73CD\u659F\u771F\u7504\u7827\u81FB\u8D1E\u9488\u4FA6\u6795\u75B9\u8BCA\u9707\u632F\u9547\u9635\u7F1C\u6862\u699B\u8F78\u8D48\u80D7\u6715\u796F\u755B\u9E29",
  zheng: "\u84B8\u6323\u7741\u5F81\u72F0\u4E89\u6014\u6574\u62EF\u6B63\u653F\u5E27\u75C7\u90D1\u8BC1\u8BE4\u5CE5\u94B2\u94EE\u7B5D",
  zhi: "\u829D\u679D\u652F\u5431\u8718\u77E5\u80A2\u8102\u6C41\u4E4B\u7EC7\u804C\u76F4\u690D\u6B96\u6267\u503C\u4F84\u5740\u6307\u6B62\u8DBE\u53EA\u65E8\u7EB8\u5FD7\u631A\u63B7\u81F3\u81F4\u7F6E\u5E1C\u5CD9\u5236\u667A\u79E9\u7A1A\u8D28\u7099\u75D4\u6EDE\u6CBB\u7A92\u536E\u965F\u90C5\u57F4\u82B7\u646D\u5E19\u5FEE\u5F58\u54AB\u9A98\u6809\u67B3\u6800\u684E\u8F75\u8F7E\u6534\u8D3D\u81A3\u7949\u7957\u9EF9\u96C9\u9E37\u75E3\u86ED\u7D77\u916F\u8DD6\u8E2C\u8E2F\u8C78\u89EF",
  zhong: "\u4E2D\u76C5\u5FE0\u949F\u8877\u7EC8\u79CD\u80BF\u91CD\u4EF2\u4F17\u51A2\u953A\u87BD\u8202\u822F\u8E35",
  zhou: "\u821F\u5468\u5DDE\u6D32\u8BCC\u7CA5\u8F74\u8098\u5E1A\u5492\u76B1\u5B99\u663C\u9AA4\u5544\u7740\u501C\u8BF9\u836E\u9B3B\u7EA3\u80C4\u78A1\u7C40\u8233\u914E\u9CB7",
  zhu: "\u73E0\u682A\u86DB\u6731\u732A\u8BF8\u8BDB\u9010\u7AF9\u70DB\u716E\u62C4\u77A9\u5631\u4E3B\u8457\u67F1\u52A9\u86C0\u8D2E\u94F8\u7B51\u4F4F\u6CE8\u795D\u9A7B\u4F2B\u4F8F\u90BE\u82CE\u8331\u6D19\u6E1A\u6F74\u9A7A\u677C\u69E0\u6A65\u70B7\u94E2\u75B0\u7603\u86B0\u7AFA\u7BB8\u7FE5\u8E85\u9E88",
  zhua: "\u6293",
  zhuai: "\u62FD",
  zhuan: "\u4E13\u7816\u8F6C\u64B0\u8D5A\u7BC6\u629F\u556D\u989B",
  zhuang: "\u6869\u5E84\u88C5\u5986\u649E\u58EE\u72B6\u4E2C",
  zhui: "\u690E\u9525\u8FFD\u8D58\u5760\u7F00\u8411\u9A93\u7F12",
  zhun: "\u8C06\u51C6",
  zhuo: "\u6349\u62D9\u5353\u684C\u7422\u8301\u914C\u707C\u6D4A\u502C\u8BFC\u5EF4\u855E\u64E2\u555C\u6D5E\u6DBF\u6753\u712F\u799A\u65AB",
  zi: "\u5179\u54A8\u8D44\u59FF\u6ECB\u6DC4\u5B5C\u7D2B\u4ED4\u7C7D\u6ED3\u5B50\u81EA\u6E0D\u5B57\u8C18\u5D6B\u59CA\u5B73\u7F01\u6893\u8F8E\u8D40\u6063\u7726\u9531\u79ED\u8014\u7B2B\u7CA2\u89DC\u8A3E\u9CBB\u9AED",
  zong: "\u9B03\u68D5\u8E2A\u5B97\u7EFC\u603B\u7EB5\u8159\u7CBD",
  zou: "\u90B9\u8D70\u594F\u63CD\u9139\u9CB0",
  zu: "\u79DF\u8DB3\u5352\u65CF\u7956\u8BC5\u963B\u7EC4\u4FCE\u83F9\u5550\u5F82\u9A75\u8E74",
  zuan: "\u94BB\u7E82\u6525\u7F35",
  zui: "\u5634\u9189\u6700\u7F6A",
  zun: "\u5C0A\u9075\u6499\u6A3D\u9CDF",
  zuo: "\u6628\u5DE6\u4F50\u67DE\u505A\u4F5C\u5750\u5EA7\u961D\u963C\u80D9\u795A\u9162",
  cou: "\u85AE\u6971\u8F8F\u8160",
  nang: "\u652E\u54DD\u56D4\u9995\u66E9",
  o: "\u5594",
  dia: "\u55F2",
  chuai: "\u562C\u81AA\u8E39",
  cen: "\u5C91\u6D94",
  diu: "\u94E5",
  nou: "\u8028",
  fou: "\u7F36",
  bia: "\u9ADF"
};
const _PinYinInteractor = class {
  static setPackage(value) {
    this._pinyin = value;
  }
  static async getPinyin(str, formatFn) {
    var _a;
    if (!str || str.includes("*")) {
      return "";
    }
    if (!this._pinyin) {
      await this._initPackage();
    }
    let pinyinArr = [];
    const chinese = ((_a = str.match(/[\u4e00-\u9fa5·]+/g)) == null ? void 0 : _a.join("")) || "";
    if (this._pinyin.isSupported()) {
      pinyinArr = this._getPinYinList(chinese);
    } else {
      pinyinArr = await this._convertPinyin(chinese);
    }
    if (formatFn && typeof formatFn === "function") {
      return formatFn.call(this, pinyinArr);
    }
    if (str !== chinese) {
      const startStr = str.substring(0, str.indexOf(chinese));
      const endStr = str.substring(
        str.indexOf(chinese) + chinese.length,
        str.length + 1
      );
      if (startStr)
        pinyinArr.splice(0, 0, str.substring(0, str.indexOf(chinese)));
      if (endStr)
        pinyinArr.push(
          str.substring(str.indexOf(chinese) + chinese.length, str.length + 1)
        );
    }
    let pinyinStr = pinyinArr.length >= 2 ? this._formatPinyin(pinyinArr) : pinyinArr[0] || "";
    if (/·/gi.test(str)) {
      pinyinStr = pinyinStr.replace(/·/gi, " ");
    }
    return pinyinStr;
  }
  static async getFormatedPinyin(name) {
    const pinyin = await this.getPinyin(name);
    let familyNameSpell = "";
    let firstNameSpell = "";
    if (pinyin) {
      const pinYinValue = pinyin.toUpperCase().split(" ");
      familyNameSpell = /\s(.+)$/.test(pinyin) ? pinYinValue[0] : pinyin;
      firstNameSpell = pinyin.substring(familyNameSpell.length + 1);
    }
    return {
      familyNameSpell,
      firstNameSpell
    };
  }
  static _capitalize(str) {
    return str.charAt(0).toUpperCase() + str.slice(1);
  }
  static _formatPinyin(arr) {
    let result = "";
    switch (arr.length) {
      case 4: {
        result = this._capitalize(arr[0]) + arr[1] + " " + this._capitalize(arr[2]) + arr[3];
        break;
      }
      case 2: {
        result = this._capitalize(arr[0]) + " " + this._capitalize(arr[1]);
        break;
      }
      case 3: {
        result = this._capitalize(arr[0]) + " " + this._capitalize(arr[1]) + arr[2];
        break;
      }
      default: {
        result = this._capitalize(arr[0]) + " " + this._capitalize(arr[1]) + arr.slice(2).join(" ");
        break;
      }
    }
    return result.toUpperCase();
  }
  static _initPackage() {
    return new Promise((resolve) => {
      import("./index3.js").then(function(n) {
        return n.i;
      }).then((pinyin) => {
        _PinYinInteractor.setPackage(pinyin);
        resolve(true);
      });
    });
  }
  static _getPinYinList(name) {
    const nameTrimmed = name.replace(/\s/g, "");
    const nameArr = nameTrimmed.split("");
    let charArr = [...nameArr];
    if (nameTrimmed.includes("*")) {
      charArr = [charArr[0]];
    }
    const pinyinArr = [];
    const isChinese = charArr.every(
      (char) => char.charCodeAt(0) >= 19968 && char.charCodeAt(0) <= 40959
    );
    if (isChinese) {
      charArr.forEach((char) => {
        pinyinArr.push(this._pinyin.convertToPinyin(char, "", true));
      });
    } else {
      pinyinArr.push(this._pinyin.convertToPinyin(name, "", true));
    }
    if (nameArr.includes("*")) {
      for (let i = 1; i < nameArr.length - 1; i++) {
        pinyinArr.push("*");
      }
    }
    return pinyinArr;
  }
  static async _convertPinyin(l1) {
    const l2 = l1.length;
    let I1 = "";
    const pinyinArr = [];
    const reg = new RegExp("[a-zA-Z0-9- ]");
    for (let i = 0; i < l2; i++) {
      const val = l1.substr(i, 1);
      const name = await this._search(val);
      if (reg.test(val)) {
        I1 += val;
      } else if (name !== false) {
        pinyinArr.push(name);
      }
    }
    I1 = I1.replace(/ /g, "-");
    while (I1.indexOf("--") > -1) {
      I1 = I1.replace("--", "-");
    }
    return pinyinArr;
  }
  static async _search(l1) {
    for (const name in this._PIN_YIN_DATA) {
      if (this._PIN_YIN_DATA[name].indexOf(l1) !== -1) {
        return name;
      }
    }
    return false;
  }
};
let PinYinInteractor = _PinYinInteractor;
__publicField(PinYinInteractor, "_pinyin");
__publicField(PinYinInteractor, "_PIN_YIN_DATA", pinyinData);
const ERROR_MSG_MAP = {
  required: "\u4E0D\u80FD\u4E3A\u7A7A",
  id18: "\u8BF7\u8F93\u5165\u6B63\u786E\u768418\u4F4D\u8EAB\u4EFD\u8BC1",
  hkOrMacaoIdCard: "\u8F93\u5165\u7684\u6E2F\u6FB3\u53F0\u5C45\u6C11\u5C45\u4F4F\u8BC1\u683C\u5F0F\u9519\u8BEF",
  id18Baidu: "\u8BF7\u8F93\u5165\u6B63\u786E\u7684\u8EAB\u4EFD\u8BC1",
  passPortId: "\u8BF7\u8F93\u5165\u957F\u5EA67\u4F4D~9\u4F4D\u7684\u5B57\u7B26,\u5141\u8BB8\u5F55\u5165\u5927\u5199\u5B57\u6BCD\u548C\u963F\u62C9\u4F2F\u6570\u5B57\u7EC4\u5408\u3001\u6216\u7EAF\u6570\u5B57",
  armypass: "\u8BF7\u8F93\u5165\u6B63\u786E\u7684\u519B\u4EBA\u8BC1",
  HMTCardId: "\u8BF7\u8F93\u5165\u6B63\u786E\u7684\u6E2F\u6FB3\u56DE\u4E61\u8BC1\u6216\u53F0\u80DE\u8BC1",
  unifySocialCreditCode: "\u7EDF\u4E00\u793E\u4F1A\u4FE1\u7528\u4EE3\u7801\u753118\u4F4D\u5927\u5199\u5B57\u6BCD \u3001\u6570\u5B57\u7EC4\u6210",
  icCard: "\u4E34\u65F6\u8EAB\u4EFD\u8BC1\u6700\u957F\u53EA\u80FD\u8F93\u516520\u4E2A\u5B57\u7B26",
  organizationCode: "9\u4F4D\u5927\u5199\u5B57\u6BCD\u548C\u6570\u5B57\u7EC4\u5408",
  taxationCode: "15/18/20\u4F4D\u5927\u5199\u5B57\u6BCD\u548C\u6570\u5B57\u7EC4\u5408",
  businessLicenseCode: "15/18\u4F4D\u5927\u5199\u5B57\u6BCD\u548C\u6570\u5B57\u7EC4\u5408",
  illegalNameSymbol: "\u4E0D\u80FD\u51FA\u73B0\u8FDE\u7EED'\xB7'",
  illegalNameSymbol2: "\u9996\u5C3E\u4E0D\u80FD\u51FA\u73B0'\xB7'",
  illegalNameSymbol3: "\u4FE1\u606F\u4E2D\u90E8\u4E0D\u80FD\u51FA\u73B0\u8FDE\u7EED\u7A7A\u683C",
  illegalNameSymbol4: "\u9664\u672B\u5C3E\u8131\u654F\u201C*\u201D\u53F7\u5916\u4E0D\u80FD\u51FA\u73B0\u201C*\u201D",
  illegaString: "\u4E0D\u80FD\u4E3A'\u4E0D\u8BE6','\u4E0D\u7965','\u672A\u77E5','\u4E0D\u77E5\u9053'",
  illegaString1: '\u53EA\u80FD\u5F55\u5165\u4E2D\u6587\u548C\u7B26\u53F7"\xB7"',
  illegaString2: '\u53EA\u80FD\u5F55\u5165\u4E2D\u6587\u3001\u5B57\u6BCD\u3001\u7A7A\u683C\u3001\u7B26\u53F7"\xB7"',
  illegaString3: "\u5141\u8BB8\u5F55\u5165\u7684\u89C4\u5219\u7EC4\u5408\uFF1A\u7EAF\u5927\u5199\u5B57\u6BCD\u3001\u5927\u5199\u5B57\u6BCD\u52A0\u4E0A\u7A7A\u683C\u3001\u7EAF\u4E2D\u6587\u3001\u4E2D\u6587\u52A0\u4E0A\u7B26\u53F7'\xB7'",
  illegaString4: "\u53EA\u80FD\u5F55\u5165\u4E2D\u6587\u3001\u5927\u5199\u5B57\u6BCD",
  illegaString5: "\u4E0D\u80FD\u51FA\u73B0\u201C\uFF1F\u201D,\u201C*\u201D,\u201C\u2605\u201D,\u201C\u3001\u201D,\u201C\uFF0C\u201D",
  illegaStringLength: "\u8BF7\u8F93\u516520\u4F4D\u4EE5\u5185\u5B57\u6BCD\u6216\u6570\u5B57",
  maxLength20: "\u6700\u957F20\u4F4D",
  mobilePhone: "\u8BF7\u8F93\u5165\u6B63\u786E\u768411\u4F4D\u53F7\u7801",
  linkPhone: "\u5EA7\u673A\uFF1A\u533A\u53F7\u4E3A3\u62164\u4F4D\u4E14\u4EE50\u5F00\u5934\uFF0C\u53F7\u7801\u4E3A7\u62168\u4F4D\uFF0C\u8BF7\u4EE5\uFF08-\uFF09\u5206\u5272\uFF1B\u5982\u679C\u662F400/800\u5F00\u5934\u5219\u4E3A10\u4F4D\u6570\u5B57\u3002\u624B\u673A\uFF1A11\u4F4D\u6570\u5B57",
  email: "\u53EA\u5141\u8BB8\u5F55\u5165\u534A\u89D2\u5B57\u6BCD\u3001\u534A\u89D2\u6570\u5B57\u3001\u534A\u89D2\u7B26\u53F7\u201C-\u201D\u3001\u201C_\u201D\u3001\u201C.\u201D\u3001\u201C@\u201D\uFF0C\u4E14\u4EC5\u5305\u542B\u4E00\u4E2A@",
  vehicleLicense: "\u8BF7\u8F93\u5165\u6B63\u786E\u7684\u8F66\u724C\u53F7",
  engineNo: "\u6DF1\u5733\u4EE5\u5916\u673A\u6784\u5934\u5C3E\u4E0D\u80FD\u8F93\u5165\u7A7A\u683C\uFF0C\u4E2D\u95F4\u4E0D\u80FD\u8FDE\u7EED\u8F93\u5165\u7A7A\u683C",
  numeric: "\u7EAF\u6570\u5B57",
  vehicleFrameNo: "\u8BF7\u586B\u5165\u6B63\u786E\u768417\u4F4D\u8F66\u67B6\u53F7",
  electrombileNo: '\u8F66\u724C\u53F7\u4EC5\u80FD\u7531\u6C49\u5B57\u3001\u534A\u89D2\u5927\u5199\u5B57\u6BCD\u3001\u534A\u89D2\u6570\u5B57\u6216\u534A\u89D2"*"\u3001\u534A\u89D2"-"\u53F7\u7EC4\u6210\uFF0C\u4F8B\u5982\uFF1A*-*',
  alpha: "\u53EA\u80FD\u5305\u542B\u5B57\u6BCD",
  ruleName2: "\u4E0D\u80FD\u51FA\u73B0\u6570\u5B57\uFF0C\u53CA\u975E\u6CD5\u5B57\u7B26\u5982'#%&@!\u3001'\u7B49,\u4E0D\u80FD\u51FA\u73B0'\u4E0D\u8BE6'\u3001'\u672A\u77E5'\u548C'\u4E0D\u77E5\u9053',\u4FE1\u606F\u4E2D\u90E8\u4E0D\u53EF\u51FA\u73B0\u8FDE\u7EED\u7A7A\u683C",
  floatAmount: "\u6B63\u6570\uFF0C\u4F4D\u6570\u5C0F\u4E8E\u7B49\u4E8E16\u4F4D\uFF0C\u6700\u591A2\u4F4D\u5C0F\u6570",
  rangeMinMax: (min = 0, max = 1e4, dot = 2) => `\u5E94\u5927\u4E8E\u7B49\u4E8E${min}\u5C0F\u4E8E\u7B49\u4E8E${max}\uFF0C\u6700\u591A${dot}\u4F4D\u5C0F\u6570`,
  alphaNum: (maxLen = 20) => `\u4EC5\u652F\u6301\u6570\u5B57\u6216\u5B57\u6BCD\uFF0C\u6700\u5927\u957F\u5EA6${maxLen}\u5B57\u7B26`,
  illegaStringMaxLength: (maxLen = 20) => `\u957F\u5EA6\u4E0D\u80FD\u8D85\u51FA${maxLen}\u4E2A\u5B57\u7B26`,
  loadAmountTips: "\u91D1\u989D\u4E0D\u4F4E\u4E8E",
  diffCertificateNo: "\u8BC1\u4EF6\u53F7\u4E0E\u586B\u5199\u7684\u4E0D\u4E00\u81F4\uFF0C\u8BF7\u4E0A\u4F20\u6B63\u786E\u7684\u8BC1\u4EF6\u5F71\u50CF",
  requireSpace: "\u5FC5\u987B\u4EE5\u7A7A\u683C\u9694\u5F00"
};
class BaseValidator {
  static getMobileError(value) {
    if (value === "") {
      return "";
    }
    if (/^1[3456789]\d{9}$/.test(value)) {
      return "";
    }
    return ERROR_MSG_MAP.mobilePhone;
  }
  static getLinkPhoneError(value) {
    if (value === "") {
      return "";
    }
    const regMobilePhone = /^1[3456789]\d{9}$/;
    const regFixedPhone = /^0[0-9]{2,3}-[0-9]{7,8}$/;
    const regFourZeroZero = /^400[0-9]{7}$/;
    const regEightZeroZero = /^800[0-9]{7}$/;
    if (regMobilePhone.test(value) || regFixedPhone.test(value) || regFourZeroZero.test(value) || regEightZeroZero.test(value)) {
      return "";
    }
    return ERROR_MSG_MAP.linkPhone;
  }
  static getEmailError(email) {
    if (email === "") {
      return "";
    }
    if (/^\w+([\.-]?\w)*@\w+([\.-]?\w)*(\.\w{2,3})+$/.test(email)) {
      return "";
    }
    return ERROR_MSG_MAP.email;
  }
}
const CITY_MAP = {
  11: "\u5317\u4EAC",
  12: "\u5929\u6D25",
  13: "\u6CB3\u5317",
  14: "\u5C71\u897F",
  15: "\u5185\u8499\u53E4",
  21: "\u8FBD\u5B81",
  22: "\u5409\u6797",
  23: "\u9ED1\u9F99\u6C5F ",
  31: "\u4E0A\u6D77",
  32: "\u6C5F\u82CF",
  33: "\u6D59\u6C5F",
  34: "\u5B89\u5FBD",
  35: "\u798F\u5EFA",
  36: "\u6C5F\u897F",
  37: "\u5C71\u4E1C",
  41: "\u6CB3\u5357",
  42: "\u6E56\u5317 ",
  43: "\u6E56\u5357",
  44: "\u5E7F\u4E1C",
  45: "\u5E7F\u897F",
  46: "\u6D77\u5357",
  50: "\u91CD\u5E86",
  51: "\u56DB\u5DDD",
  52: "\u8D35\u5DDE",
  53: "\u4E91\u5357",
  54: "\u897F\u85CF ",
  61: "\u9655\u897F",
  62: "\u7518\u8083",
  63: "\u9752\u6D77",
  64: "\u5B81\u590F",
  65: "\u65B0\u7586",
  71: "\u53F0\u6E7E",
  81: "\u9999\u6E2F",
  82: "\u6FB3\u95E8",
  91: "\u56FD\u5916"
};
const CERTIFICATE_TYPE_MAX_LENGTH = 20;
class CertificateNoValidator {
  static validate(certificateNo, type) {
    if (certificateNo === "")
      return "";
    if (certificateNo.toString().length > CERTIFICATE_TYPE_MAX_LENGTH) {
      return ERROR_MSG_MAP.maxLength20;
    }
    switch (type) {
      case "01":
      case "11":
      case "07":
        return this.getIdCard18Error(certificateNo);
      case "02":
        return this.getIPassPortIdError(certificateNo);
      case "03":
        return this.getIArmypassError(certificateNo);
      case "06":
        return this.getIHMTidCardError(certificateNo);
      case "09":
        return this.getHkOrMacaoIdCardError(certificateNo);
      case "g01":
        return this.getOrganizingCodeError(certificateNo);
      case "g02":
        return this.getTaxationCodeError(certificateNo);
      case "g04":
        return this.getBusinessLicenseCodeError(certificateNo);
      case "g03":
      case "g05":
        return this.getUnifySocialCreditCodeError(certificateNo);
      default:
        return "";
    }
  }
  static getIdCard18Error(idCard) {
    if (idCard === "")
      return "";
    const birthday = idCard.substr(6, 4) + "/" + Number(idCard.substr(10, 2)) + "/" + Number(idCard.substr(12, 2));
    const d = dayjs(birthday);
    const newBirthday = d.year() + "/" + Number(d.month() + 1) + "/" + Number(d.date());
    const currentTime = new Date().getTime();
    const time = d.valueOf();
    if (!/^\d{17}(\d|x)$/i.test(idCard) || CITY_MAP[idCard.substr(0, 2)] === void 0 || time >= currentTime || birthday !== newBirthday) {
      return ERROR_MSG_MAP.id18;
    }
    if (!this.isCorrectCard(idCard)) {
      return ERROR_MSG_MAP.id18;
    }
    return "";
  }
  static getHkOrMacaoIdCardError(value) {
    if (value === "")
      return "";
    const reg = /^[8]\d{5}(19\d{2}|2\d{3})(0[1-9]|[1][0-2])(0[1-9]|[12][0-9]|3[01])\d{3}[0-9xX]$/;
    if (!value || !reg.test(value))
      return ERROR_MSG_MAP.hkOrMacaoIdCard;
    if (value.length === 18 && !this.isCorrectCard(value)) {
      return ERROR_MSG_MAP.hkOrMacaoIdCard;
    }
    return "";
  }
  static getIPassPortIdError(value) {
    if (value === "")
      return "";
    const regAll = /^[A-Z\d]{7,9}$/;
    const reg = /^[A-Z]+$/;
    if (!regAll.test(value) || reg.test(value)) {
      return ERROR_MSG_MAP.passPortId;
    }
    return "";
  }
  static getIArmypassError(value) {
    if (value === "")
      return "";
    const regAll = /^((\u519b{1}\d{7})|(\d{1}\u519b{1}\d{6})|(\d{2}\u519b{1}\d{5})|(\d{3}\u519b{1}\d{4})|(\d{4}\u519b{1}\d{3})|(\d{5}\u519b{1}\d{2})|(\d{6}\u519b{1}\d{1})|(\d{7}\u519b{1}))?$/;
    return regAll.test(value) ? "" : ERROR_MSG_MAP.armypass;
  }
  static getIHMTidCardError(value) {
    if (value === "")
      return "";
    if (/^\d{8}$/.test(value) || /^[HM]\d{8,11}$/.test(value)) {
      return "";
    }
    return ERROR_MSG_MAP.HMTCardId;
  }
  static getUnifySocialCreditCodeError(value) {
    if (value === "")
      return "";
    return /^[0-9A-Z]{18}$/.test(value) ? "" : ERROR_MSG_MAP.unifySocialCreditCode;
  }
  static getOrganizingCodeError(value) {
    const organizingCode = value.trim().replace(/\s+/g, "");
    const reg = /^$|^[0-9|A-Z]{8}[0-9|X]$/;
    if (!reg.test(organizingCode)) {
      return ERROR_MSG_MAP.organizationCode;
    }
    const isOrganizingCode = this.isOrganizingCode(value);
    return isOrganizingCode ? "" : ERROR_MSG_MAP.organizationCode;
  }
  static getTaxationCodeError(taxationCode = "") {
    let ssvalid;
    let ocvalid;
    let cardDate;
    if (taxationCode === "") {
      return "";
    }
    const value = taxationCode.trim().replace(/\s+/g, "");
    const myRegExp = /^[0-9]{14}[0-9|A-Z]{1}$/;
    const myRegExp2 = /^[0-9]{18}[0-9|A-Z]{2}$/;
    const myRegExp3 = /^[0-9]{17}[X][0-9|A-Z]{2}$/;
    const myRegExp4 = /^[0-9]{2}$/;
    const myRegExpIDCardNo = /^\d{6}(((19|20)\d{2}(0[1-9]|1[0-2])(0[1-9]|[1-2][0-9]|3[0-1])\d{3}([0-9]|x|X))|(\d{2}(0[1-9]|1[0-2])(0[1-9]|[1-2][0-9]|3[0-1])\d{3}))$/;
    const valid = myRegExp.test(value) || myRegExp2.test(value) || myRegExp3.test(value) || myRegExpIDCardNo.test(value) || value.length === 17 && myRegExpIDCardNo.test(value.substring(0, 15));
    if (!valid) {
      return ERROR_MSG_MAP.taxationCode;
    }
    const length = value.length;
    switch (length) {
      case 17:
      case 20: {
        const ssIDCardNo = value.substring(0, value.length - 2);
        const orderCode = value.substring(value.length - 2, value.length);
        ocvalid = myRegExp4.test(orderCode);
        ssvalid = myRegExpIDCardNo.test(ssIDCardNo);
        if (!ocvalid || !ssvalid) {
          return ERROR_MSG_MAP.taxationCode;
        }
        if (value.length === 17) {
          cardDate = "19" + value.substring(6, 12);
          if (!this.isCorrectDate(cardDate)) {
            return ERROR_MSG_MAP.taxationCode;
          }
          return "";
        }
        cardDate = value.substring(6, 14);
        if (!this.isCorrectDate(cardDate)) {
          return ERROR_MSG_MAP.taxationCode;
        }
        const cardId = value.substring(0, 18);
        if (!this.isCorrectCard(cardId)) {
          return ERROR_MSG_MAP.taxationCode;
        }
        return "";
      }
      case 15: {
        if (!myRegExpIDCardNo.test(value)) {
          const ssOrgCode = value.substring(6, 15);
          if (this.getOrganizingCodeError(ssOrgCode)) {
            return ERROR_MSG_MAP.taxationCode;
          }
          return "";
        }
        if (myRegExpIDCardNo.test(value)) {
          cardDate = "19" + value.substring(6, 12);
          if (!this.isCorrectDate(cardDate)) {
            return ERROR_MSG_MAP.taxationCode;
          }
          return "";
        }
        return "";
      }
      case 18: {
        cardDate = value.substring(6, 14);
        if (!this.isCorrectDate(cardDate) || !this.isCorrectCard(value)) {
          return ERROR_MSG_MAP.taxationCode;
        }
        return "";
      }
      default:
        return ERROR_MSG_MAP.taxationCode;
    }
  }
  static getBusinessLicenseCodeError(value) {
    if (value === "") {
      return "";
    }
    const tmp = /^[0-9]*$/;
    const valueLength = value.length;
    if (tmp.test(value) && [13, 15].includes(valueLength)) {
      return "";
    }
    if (valueLength === 18) {
      if (!/^[a-zA-Z0-9]{2}[0-9]{6}[^]{9}[a-zA-Z0-9]$/.test(value) || !this.isOrganizingCode(value.substring(8, 17))) {
        return ERROR_MSG_MAP.businessLicenseCode;
      }
      return "";
    }
    return ERROR_MSG_MAP.businessLicenseCode;
  }
  static isCorrectDate(date) {
    if (!date) {
      return false;
    }
    const _date = date.match(
      /(19\d{2}|2\d{3})(0[1-9]|[1][0-2])(0[1-9]|[12][0-9]|3[01])/
    );
    if (!_date) {
      return false;
    }
    return Number(_date[3]) <= dayjs(date).daysInMonth();
  }
  static isCorrectCard(cardId) {
    if (!cardId)
      return false;
    if (cardId.length !== 18)
      return false;
    const lastChar = cardId[17];
    const wiParams = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
    const yParams = ["1", "0", "X", "9", "8", "7", "6", "5", "4", "3", "2"];
    let sum = 0;
    for (let i = 0; i < cardId.length - 1; i++) {
      const temp = cardId[i];
      sum = sum + parseInt(temp, 10) * wiParams[i];
    }
    const y = sum % 11;
    return lastChar === yParams[y];
  }
  static isOrganizingCode(value, options = {}) {
    const {
      reg = /^$|^[0-9|A-Z]{8}[0-9|X]$/,
      str = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    } = options;
    const organizingCode = value.trim().replace(/\s+/g, "");
    const params = [3, 7, 9, 10, 5, 8, 4, 2];
    if (!reg.test(organizingCode)) {
      return false;
    }
    let sum = 0;
    for (let i = 0; i < organizingCode.length - 1; i++) {
      const temp = organizingCode[i];
      if (!/[A-Z]/.test(temp)) {
        sum = sum + parseInt(temp, 10) * params[i];
      } else {
        sum = sum + (str.indexOf(temp) + 10) * params[i];
      }
    }
    const mod = 11 - sum % 11;
    if (mod === 10 && organizingCode[8] !== "X" || mod === 11 && organizingCode.charAt(8) !== "0" || mod !== 10 && mod !== 11 && String(mod) !== organizingCode.charAt(8)) {
      return false;
    }
    return true;
  }
}
class StringValidator {
  static illegaString(value) {
    return /不详|不祥|未知|不知道/.test(value) ? ERROR_MSG_MAP.illegaString : "";
  }
  static illegaString1(value) {
    return /^[\u4e00-\u9fa5\·]+$/.test(value) ? "" : ERROR_MSG_MAP.illegaString1;
  }
  static illegaString2(value) {
    return /[^a-zA-Z\u4e00-\u9fa5\·\s]+/.test(value) ? ERROR_MSG_MAP.illegaString2 : "";
  }
  static illegaString3(value) {
    return /[\u4e00-\u9fa5\·]+/.test(value) && /[\sA-Z]+/.test(value) ? ERROR_MSG_MAP.illegaString3 : "";
  }
  static illegaString4(value) {
    if (!value)
      return ERROR_MSG_MAP.required;
    return /[^A-Z\u4e00-\u9fa5]+/.test(value) ? ERROR_MSG_MAP.illegaString4 : "";
  }
  static illegaString5(value) {
    return /[*★、，？]/g.test(value) ? ERROR_MSG_MAP.illegaString5 : "";
  }
  static illegaStringSymbol(value) {
    return /[^\s]+[\·]{2,}[^\s]+/.test(value) ? ERROR_MSG_MAP.illegalNameSymbol : "";
  }
  static illegaStringSymbol2(value) {
    return /^\·|\·$/.test(value) ? ERROR_MSG_MAP.illegalNameSymbol2 : "";
  }
  static illegaStringSymbol3(value) {
    return /\s{2,}/.test(value) ? ERROR_MSG_MAP.illegalNameSymbol3 : "";
  }
  static illegaStringSymbol4(value) {
    if (value.endsWith("*")) {
      return /^\*?\*$/.test(value.substr(value.indexOf("*"), value.length)) ? ERROR_MSG_MAP.illegalNameSymbol4 : "";
    }
    return "";
  }
  static illegaChineseLength(value, options = {}) {
    const {
      maxLength = 150,
      minLength = 2,
      errorTips = ""
    } = options;
    const regChinese = /[\u4e00-\u9fa5]/g;
    let chineseNum = 0;
    const errorMsg = errorTips || `\u5F55\u5165\u8303\u56F4\u4E3A\u6700\u5C11${minLength}\u4F4D\u6C49\u5B57\uFF0C\u4E14\u4E0D\u8D85\u8FC7${maxLength}\u4F4D\u5B57\u7B26`;
    value.replace(regChinese, () => {
      chineseNum++;
      return "";
    });
    if (value.length + chineseNum > maxLength) {
      return errorMsg;
    }
    const regAll = /[^A-Z\u4e00-\u9fa5\·\s]+/;
    if (chineseNum && !regAll.test(value)) {
      chineseNum = chineseNum * 2;
    }
    let num = 0;
    if (value.length < minLength * 2) {
      if (chineseNum !== 0) {
        num = value.length - 1;
      }
      if (num + chineseNum < minLength * 2) {
        return errorMsg;
      }
    }
    return "";
  }
  static illegaStringLength(value) {
    if (!value)
      return "";
    const reg = /^[a-zA-Z0-9]{1,20}$/;
    if (!reg.test(value))
      return ERROR_MSG_MAP.illegaStringLength;
    return "";
  }
  static illegaStringMaxLength(value, maxLen) {
    if (!value)
      return "";
    if (String(value).length > maxLen)
      return ERROR_MSG_MAP.illegaStringMaxLength(maxLen);
    return "";
  }
  static alpha(value) {
    if (!value)
      return "";
    if (!/^[a-zA-Z]+$/.test(value))
      return ERROR_MSG_MAP.alpha;
    return "";
  }
  static ruleName2(value) {
    if (typeof value === "undefined" || value === null || value === "") {
      return "";
    }
    const trim = /[^\s]+[\s]{1,}[^\s]+/;
    const regAll = /[\a-z\A-Z\u2500-\u257F\.~!@#￥%……&*【】、{}|；‘’：“”，。、《》？\~!@#\$%^&*`\[\]\\{}|;’:”,\/<>\?\d0-9\§№☆★○●◎◇◆□℃‰€°¤〓↓↑←→※▲△■＃＆＠＼︿＿￣―♂♀\≈≡≠＝≤≥＜＞≮≯∷∞∝∮∫／÷×－＋±∧∑∨∏∪∩∈∵∴√∽≌⊙⌒∠∥⊥ⅠⅡⅢⅣⅤⅥⅦⅧⅨⅩⅪⅫ⒈⒉⒊⒋⒌⒍⒎⒏⒐⒑㈠㈡㈢㈣㈤㈥㈦㈧㈨㈩⑴⑵⑶⑷⑸⑹⑺⑻⑼⑽⒒⒓⒔⒕⒖⒗⒘⒙⒚⒛①②③④⑤⑥⑦⑧⑨⑩⑾⑿⒀⒁⒂⒃⒄⒅⒆⒇āáǎàōóǒòêìǐíīèěéēūúǔùǖǘǚǜü\，、；：？！…—ˉ¨〔〕()〈〉《》「」『』〖〗【】［］｛｝]/g;
    if (value === "\u4E0D\u8BE6" || value === "\u672A\u77E5" || value === "\u4E0D\u77E5\u9053") {
      return ERROR_MSG_MAP.ruleName2;
    }
    if (regAll.test(value)) {
      return ERROR_MSG_MAP.ruleName2;
    }
    if (trim.test(value)) {
      return ERROR_MSG_MAP.ruleName2;
    }
    return "";
  }
  static ruleRareWords(value) {
    if (!value)
      return ERROR_MSG_MAP.required;
    return /(^[A-Z\u2E80-\uFE4F]{2,32}$)/.test(value) ? "" : ERROR_MSG_MAP.illegaString4;
  }
}
class VehicleValidator {
  static getVehicleLicenceError(vehicleLicence) {
    if (!vehicleLicence || /^[\u4E00-\u9FA5][A-Z]{1}[-]$/.test(vehicleLicence)) {
      return "";
    }
    if (!/^[^-]+[-][^-]+$/.test(vehicleLicence) || /\s/.test(vehicleLicence) || !/^[\u4E00-\u9FA5][A-Z]{1}[-][0-9A-Z\u4E00-\u9FA5]{5}/.test(vehicleLicence)) {
      return ERROR_MSG_MAP.vehicleLicense;
    }
    return "";
  }
  static getEngineNoError(engineNo) {
    if (!engineNo) {
      return "";
    }
    if (/ /.test(engineNo) || !/^\S(\s?\S+)*$/.test(engineNo)) {
      return ERROR_MSG_MAP.engineNo;
    }
    if (/^[\u4e00-\u9fa5a-zA-Z0-9\.\`\~\!\@\#\$\%\^\&\*\(\)\_\+\-\=\[\]\{\}\\\|\;\:\'\"\<\>\,\?\/\s]*$/.test(engineNo)) {
      return "";
    }
    return ERROR_MSG_MAP.engineNo;
  }
  static getVehicleFrameNoError(vehicleFrameNo) {
    if (!vehicleFrameNo) {
      return "";
    }
    if (vehicleFrameNo.length !== 17 || vehicleFrameNo.includes(" ")) {
      return ERROR_MSG_MAP.vehicleFrameNo;
    }
    if (/^[\u4e00-\u9fa5a-zA-Z0-9\.\`\~\!\@\#\$\%\^\&\(\)\_\+\-\=\[\]\{\}\\\|\;\:\'\"\<\>\,\?\/]*$/.test(vehicleFrameNo)) {
      return "";
    }
    return ERROR_MSG_MAP.vehicleFrameNo;
  }
  static getNonMotorVehicleNoError(value) {
    if (!value)
      return "";
    if (value.indexOf(" ") > -1)
      return ERROR_MSG_MAP.electrombileNo;
    if (!/^[^-]+[-][^-]+$/.test(value))
      return ERROR_MSG_MAP.electrombileNo;
    if (!/^[\u4e00-\u9fa5A-Z0-9\*\-]*$/.test(value))
      return ERROR_MSG_MAP.electrombileNo;
    if (value.length > 50)
      return "\u8F66\u724C\u53F7\u957F\u5EA6\u4E0D\u80FD\u8D85\u8FC750";
    return "";
  }
}
class NumberValidator {
  static rangeMinMax(value, min = 0, max = 1e4, dot = 2) {
    if (typeof value === "undefined" || value === null || value === "") {
      return "";
    }
    const val = Number(value);
    const str = "" + value;
    const dotNum = str.split(".")[1];
    if (dotNum && dotNum.length > dot) {
      return ERROR_MSG_MAP.rangeMinMax(min, max, dot);
    }
    if (isNaN(val) || val > max || val < min) {
      return ERROR_MSG_MAP.rangeMinMax(min, max, dot);
    }
    return "";
  }
}
const validateCertificateNo = (certificateNo, certificateType) => CertificateNoValidator.validate(certificateNo, certificateType);
const validateEmail = (email) => BaseValidator.getEmailError(email);
const validatePhoneNumber = (phoneNumber, isMobile = true) => isMobile ? BaseValidator.getMobileError(phoneNumber) : BaseValidator.getLinkPhoneError(phoneNumber);
const validateVehicleFrameNo = (vehicleFrameNo) => VehicleValidator.getVehicleFrameNoError(vehicleFrameNo);
const validateVehicleEngineNo = (engineNo) => VehicleValidator.getEngineNoError(engineNo);
const validateVehicleLicence = (vehicleLicence, isNonMotor = false) => isNonMotor ? VehicleValidator.getNonMotorVehicleNoError(vehicleLicence) : VehicleValidator.getVehicleLicenceError(vehicleLicence);
function removeNode(el) {
  const parent = el.parentNode;
  if (parent) {
    parent.removeChild(el);
  }
}
function htmlOpen(info) {
  let myWindow = window.open("", "", "width:100%,height:100%");
  if (!myWindow)
    return;
  myWindow.document.write(info);
  myWindow.document.close();
  myWindow.focus();
}
const judgeEmptyObjects = (obj) => {
  return !Object.keys(obj).length;
};
const RandomNumber = (length = 10) => {
  const pow = Math.pow(10, length);
  return Math.floor(Math.random() * pow);
};
const objectToFormData = (data) => {
  let formData = new FormData();
  for (const [key, value] of Object.entries(data)) {
    if (value !== null && value !== void 0) {
      if (value instanceof Object) {
        formData.append(key, JSON.stringify(value));
      } else {
        formData.append(key, value);
      }
    } else {
      formData.append(key, "");
    }
  }
  return formData;
};
const objectToArray = (data) => {
  let arr = [];
  for (const [key, value] of Object.entries(data)) {
    if (value !== null && value !== void 0) {
      arr.push(value);
    }
  }
  return arr;
};
const arrayToObject = (data) => {
  let arr = {};
  data.forEach((val) => {
    arr[val] = val;
  });
  return arr;
};
const filterEmpty = (value, isExclude) => {
  if (isExclude) {
    return false;
  }
  if (isNil(value) || value === "") {
    return true;
  }
  return false;
};
const filterEmptyValue = (jsonValue, excludeKeys = []) => {
  if (jsonValue && Object.keys(jsonValue).length > 0) {
    return omitBy(
      jsonValue,
      (value, key) => filterEmpty(value, excludeKeys.includes(key))
    );
  }
  return jsonValue;
};
const arrToObj = (arr) => {
  let obj = {};
  arr.forEach((item) => {
    obj[item] = item;
  });
  return obj;
};
const arrToObjTwo = (arr, arr2) => {
  let obj = {};
  arr.forEach((item, index) => {
    obj[arr2[index]] = item;
  });
  return obj;
};
const changeTableHead = (tableData, fieldName) => {
  const list = tableData.map((item) => {
    const obj = {};
    for (const k in item) {
      if (fieldName[k]) {
        obj[fieldName[k]] = item[k];
      }
    }
    return obj;
  });
  return list;
};
const transferred = (data) => {
  return data.replace(/<br>/g, "rn").replace(/&gt;/g, ">");
};
const roundNum = function(num, precision) {
  const multiNo = Math.pow(10, precision || 2);
  return Math.round(num * multiNo) / multiNo;
};
const scientificNotationFormat = function(arg) {
  try {
    if ((arg == null ? void 0 : arg.toString().toLowerCase().indexOf("e")) !== -1) {
      arg = Number(arg);
    }
  } catch (e) {
    console.error(e);
  }
  return arg;
};
const floatAdd = function(arg1, arg2) {
  let r1;
  let r2;
  try {
    arg1 = scientificNotationFormat(arg1);
    r1 = arg1.toString().split(".")[1].length;
  } catch (e) {
    r1 = 0;
  }
  try {
    arg2 = scientificNotationFormat(arg2);
    r2 = arg2.toString().split(".")[1].length;
  } catch (e) {
    r2 = 0;
  }
  const m = Math.pow(10, Math.max(r1, r2));
  return (Number(arg1) * m + Number(arg2) * m) / m;
};
const floatSub = function(arg1, arg2) {
  let r1, r2;
  try {
    arg1 = scientificNotationFormat(arg1);
    r1 = arg1.toString().split(".")[1].length;
  } catch (e) {
    r1 = 0;
  }
  try {
    arg2 = scientificNotationFormat(arg2);
    r2 = arg2.toString().split(".")[1].length;
  } catch (e) {
    r2 = 0;
  }
  const m = Math.pow(10, Math.max(r1, r2));
  const n = r1 >= r2 ? r1 : r2;
  return Number(((Number(arg1) * m - Number(arg2) * m) / m).toFixed(n));
};
const floatMul = function(arg1, arg2) {
  let m = 0;
  arg1 = scientificNotationFormat(arg1);
  arg2 = scientificNotationFormat(arg2);
  const s1 = arg1.toString();
  const s2 = arg2.toString();
  if (s1.indexOf(".") !== -1) {
    m += s1.split(".")[1].length;
  }
  if (s2.indexOf(".") !== -1) {
    m += s2.split(".")[1].length;
  }
  return Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m);
};
const floatDiv = function(arg1, arg2) {
  let t1 = 0;
  let t2 = 0;
  let res;
  arg1 = scientificNotationFormat(arg1);
  arg2 = scientificNotationFormat(arg2);
  const s1 = arg1.toString();
  const s2 = arg2.toString();
  if (s1.indexOf(".") !== -1) {
    t1 = s1.split(".")[1].length;
  }
  if (s2.indexOf(".") !== -1) {
    t2 = s2.split(".")[1].length;
  }
  const r1 = Number(s1.replace(".", ""));
  const r2 = Number(s2.replace(".", ""));
  res = (r1 / r2).toString();
  if (res.indexOf(".") !== -1) {
    t1 += res.split(".")[1].length;
    res = res.replace(".", "");
  }
  return Number(res) / Math.pow(10, t1 - t2);
};
const numberUtils = {
  add: (arg1, arg2, precision = 2) => roundNum(floatAdd(arg1, arg2), precision),
  sub: (arg1, arg2, precision = 2) => roundNum(floatSub(arg1, arg2), precision),
  mul: (arg1, arg2, precision = 2) => roundNum(floatMul(arg1, arg2), precision),
  div: (arg1, arg2, precision = 2) => arg2 ? roundNum(floatDiv(arg1, arg2), precision) : 0,
  toPercent: (arg) => `${arg * 100}%`
};
const LOCAL_STORAGE_NAME = "localStorage";
const LOCAL_STORAGE_OVERTIME_KEY = "_overtime_";
const LOCAL_STORAGE_DATA_KEY = "_data_";
class StorageUtils {
  static setItem(storeKey, value, type = LOCAL_STORAGE_NAME, cacheEffectiveHour = this._CACHE_EFFECTIVE_LIMIT_HOUR) {
    if (!storeKey) {
      return;
    }
    const storage = this._getStorage(type);
    storage == null ? void 0 : storage.setItem(storeKey, JSON.stringify({
      [LOCAL_STORAGE_OVERTIME_KEY]: dayjs().add(cacheEffectiveHour, "h").valueOf(),
      [LOCAL_STORAGE_DATA_KEY]: value
    }));
  }
  static getItem(storeKey, type = LOCAL_STORAGE_NAME, needTime = false) {
    var _a;
    const storage = this._getStorage(type);
    const value = storage == null ? void 0 : storage.getItem(storeKey);
    if (value) {
      const storeData = JSON.parse(value);
      if (!(storeData == null ? void 0 : storeData[LOCAL_STORAGE_OVERTIME_KEY])) {
        return storeData;
      }
      if (dayjs(storeData[LOCAL_STORAGE_OVERTIME_KEY]).isBefore(dayjs())) {
        this.removeItem(storeKey, type);
        return null;
      }
      if (needTime) {
        return storeData;
      }
      return (_a = storeData == null ? void 0 : storeData[LOCAL_STORAGE_DATA_KEY]) != null ? _a : storeData;
    }
    return null;
  }
  static setHashItem(storeKey, hashKey, value, type = LOCAL_STORAGE_NAME) {
    if (!storeKey) {
      return;
    }
    const storage = this._getStorage(type);
    const storageItem = this.getItem(storeKey, type) || {};
    storageItem[hashKey] = value;
    storage == null ? void 0 : storage.setItem(storeKey, JSON.stringify(storageItem));
  }
  static getHashItem(storeKey, hashKey, type = LOCAL_STORAGE_NAME) {
    if (!storeKey || !hashKey) {
      return;
    }
    const storageItem = this.getItem(storeKey, type);
    return storageItem == null ? void 0 : storageItem[hashKey];
  }
  static removeItem(storeKey, type = LOCAL_STORAGE_NAME) {
    const storage = this._getStorage(type);
    storage == null ? void 0 : storage.removeItem(storeKey);
  }
  static clear(type = LOCAL_STORAGE_NAME) {
    const storage = this._getStorage(type);
    storage == null ? void 0 : storage.clear();
  }
  static size(type = LOCAL_STORAGE_NAME) {
    const storage = this._getStorage(type);
    return (storage == null ? void 0 : storage.length) || 0;
  }
  static key(index, type = LOCAL_STORAGE_NAME) {
    const storage = this._getStorage(type);
    return (storage == null ? void 0 : storage.key(index)) || "";
  }
  static isSupport(type = LOCAL_STORAGE_NAME) {
    return !!this._getStorage(type);
  }
  static _getStorage(type = LOCAL_STORAGE_NAME) {
    const storage = window[type];
    if (!storage) {
      console.warn(`\u5F53\u524D\u73AF\u5883\u4E0D\u652F\u6301\u672C\u5730\u5B58\u50A8: ${type}`);
      return null;
    }
    return storage;
  }
}
__publicField(StorageUtils, "_CACHE_EFFECTIVE_LIMIT_HOUR", 6);
const charLength = (param) => {
  try {
    const arr = param.match(/[\u4e00-\u9fa5]/gi) || [];
    return param.length + arr.length;
  } catch (e) {
    console.error(new Error("stringUtils.charLength parameter error"), e);
  }
};
const decodeParams64 = (param) => {
  let result = param;
  if (typeof param !== "undefined" && param !== null && param !== "" && param !== "undefined" && param !== "null") {
    try {
      result = window.decodeURIComponent(window.atob(param));
    } catch (e) {
      console.warn(e);
    }
  }
  return result;
};
const encodeParams64 = (param) => {
  let result = param;
  if (typeof param !== "undefined" && param !== null && param !== "" && param !== "undefined" && param !== "null") {
    try {
      result = window.btoa(window.encodeURIComponent(param));
    } catch (err) {
      console.error(err);
    }
  }
  return result;
};
const desensitization = (value) => {
  if (!value) {
    return value;
  }
  const targetValue = `${value}`;
  const length = targetValue.length;
  const maxLength = Math.min(Math.floor(length / 2), 4);
  const regex = new RegExp(`.{${maxLength}}$`, "i");
  const replaceStr = "*".repeat(maxLength);
  return targetValue.replace(regex, replaceStr);
};
var encode = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  charLength,
  decodeParams64,
  encodeParams64,
  desensitization
}, Symbol.toStringTag, { value: "Module" }));
const blobFileDown = (blob, fileName) => {
  const url = URL.createObjectURL(blob);
  const downloadLink = document.createElement("a");
  downloadLink.href = url;
  downloadLink.download = fileName;
  downloadLink.hidden = true;
  document.body.appendChild(downloadLink);
  downloadLink.click();
  document.body.removeChild(downloadLink);
};
const downloadImage = (imgsrc, name, type = "png") => {
  const image = new Image();
  image.setAttribute("crossOrigin", "anonymous");
  image.onload = function() {
    const canvas = document.createElement("canvas");
    canvas.width = image.width;
    canvas.height = image.height;
    const context = canvas.getContext("2d");
    context == null ? void 0 : context.drawImage(image, 0, 0, image.width, image.height);
    let url = canvas.toDataURL(`image/${type}`);
    let a = document.createElement("a");
    let event = new MouseEvent("click");
    a.download = name || "pic";
    a.href = url;
    a.dispatchEvent(event);
    removeNode(canvas);
  };
  image.src = imgsrc;
};
const downloadImageTwo = (src, name, type = "png") => {
  const img = document.createElement("img");
  img.setAttribute("crossOrigin", "Anonymous");
  img.onload = function(e) {
    const canvas = document.createElement("canvas");
    canvas.width = img.width;
    canvas.height = img.height;
    let context = canvas.getContext("2d");
    context == null ? void 0 : context.drawImage(img, 0, 0, img.width, img.height);
    canvas.toBlob((blob) => {
      let link = document.createElement("a");
      link.href = window.URL.createObjectURL(blob);
      link.download = name;
      link.click();
      removeNode(canvas);
    }, `image/${type}`);
  };
  img.src = src;
};
const downloadImgFile = (file, fileName) => {
  const blob = new Blob([file]);
  const fileReader = new FileReader();
  fileReader.readAsDataURL(blob);
  fileReader.onload = (e) => {
    var _a;
    const a = document.createElement("a");
    a.download = fileName || "0123456.PNG";
    a.href = (_a = e.target) == null ? void 0 : _a.result;
    document.body.appendChild(a);
    a.click();
    document.body.removeChild(a);
  };
};
const downloadFileUrl = (file) => {
  const blob = new Blob([file]);
  const fileReader = new FileReader();
  fileReader.readAsDataURL(blob);
  fileReader.onload = (e) => {
    var _a;
    const url = (_a = e.target) == null ? void 0 : _a.result;
    downloadImage(`data:image/png;Base64,${url}`, "testefd");
  };
};
function getFileUrl(data, tranformmation = true) {
  if (!data)
    return false;
  const url = tranformmation ? window.URL.createObjectURL(new Blob([data])) : data;
  return url;
}
function downloadFile(data, filename = "export.xlsx", tranformmation = true) {
  const url = getFileUrl(data, tranformmation);
  if (!url) {
    return;
  }
  let a = document.getElementById("download-file");
  if (!a) {
    a = document.createElement("a");
    a.setAttribute("id", "download-file");
    document.body.appendChild(a);
    a.style.display = "none";
  }
  a.setAttribute("download", filename);
  a.href = url;
  a.click();
}
function arraybufferToJson(arraybuffer) {
  const utf8decoder = new TextDecoder();
  const u8arr = new Uint8Array(arraybuffer);
  try {
    return JSON.parse(utf8decoder.decode(u8arr));
  } catch (error) {
    console.error(error.message);
    return false;
  }
}
const formDataDownFile = (action, params, method = "post", parent = "app") => {
  const App = document.getElementById(parent);
  const form = document.createElement("form");
  form.method = `${method}`;
  form.target = "downloadBox";
  form.action = action;
  for (const key in params) {
    if (Object.prototype.hasOwnProperty.call(params, key)) {
      let element = params[key];
      if (typeof element !== "string") {
        element = JSON.stringify(element);
      }
      form.appendChild(createInputElement(key, element));
    }
  }
  App == null ? void 0 : App.appendChild(form);
  form.submit();
  App == null ? void 0 : App.removeChild(form);
};
const createInputElement = (name, value, type = "text") => {
  const input = document.createElement("input");
  input.name = name;
  input.value = value;
  input.type = type;
  return input;
};
const exportExcel = (fileName = "demo", pageName = "Sheet1") => {
  const table = getHtmlTableData();
  const fieldName = arrToObj(table.ths);
  const tableData = table.trs.map((tr) => {
    return arrToObjTwo(tr, table.ths);
  });
  const list = changeTableHead(tableData, fieldName);
  const data = utils.json_to_sheet(list);
  const wb = utils.book_new();
  utils.book_append_sheet(wb, data, pageName);
  writeFileSync(wb, `${fileName}.xlsx`);
};
const getHtmlTableData = () => {
  const table__header = document.getElementsByClassName("el-table__header");
  const table__body = document.getElementsByClassName("el-table__body")[0];
  const ths = table__header[0].innerText.split("\n	\n");
  const trss = table__body.getElementsByTagName("tr");
  let trs = [];
  for (let i = 0, l = trss.length; i < l; i++) {
    trs.push([]);
    trs[i] = trss[i].innerText.split("\n	\n");
  }
  return {
    ths,
    trs
  };
};
const downloadTableToCSV = (fileName) => {
  const columnDelimiter = ",";
  const lineDelimiter = "\n	";
  let result = "";
  const table = getHtmlTableData();
  for (let i = 0, l = table.ths.length; i < l; i++) {
    result += transferred('"' + table.ths[i] + '"') + columnDelimiter;
  }
  result += lineDelimiter;
  for (let i = 0, l = table.trs.length; i < l; i++) {
    let spandata = table.trs[i];
    for (let i2 = 0, l2 = spandata.length; i2 < l2; i2++) {
      result += transferred('"' + spandata[i2] + '"') + columnDelimiter;
    }
    result += lineDelimiter;
  }
  const blob = new Blob([result], { type: "text/csv" });
  blobFileDown(blob, fileName);
};
export { AMapInteractor, ExportBriefDataDocx, ImageUploadErrorCodeEnum, LOCAL_STORAGE_DATA_KEY, LOCAL_STORAGE_OVERTIME_KEY, PinYinInteractor, RandomNumber, StorageUtils, WechatSdk, WechatUtils, arrToObj, arrToObjTwo, arrayToObject, arraybufferToJson, asyncAmapMap, asyncScript, base64ToFile, base64toBlob, blobFileDown, changeTableHead, charLength, checkFileType, compressCanvesToFile, compressFile, compressFileToDataURL, compressUploader, createInputElement, decodeParams64, desensitization, downloadFile, downloadFileUrl, downloadImage, downloadImageTwo, downloadImgFile, downloadTableToCSV, enCodeUrlParams, encodeParams64, EnvUtils as envUtils, exportExcel, filterEmptyValue, formDataDownFile, getFileUrl, getHtmlTableData, getImageData, getOrientation, getUrlQuery, getUrlQuerys, getUrlTemplateCode, getXlsxFileData, htmlOpen, judgeEmptyObjects, numberUtils, objectToArray, objectToFormData, overrideMimeTypeXML, readFile, removeNode, encode as stringUtils, transferred, urlToBase64, uuid, validateCertificateNo, validateEmail, validatePhoneNumber, StringValidator as validateStringUtils, validateVehicleEngineNo, validateVehicleFrameNo, validateVehicleLicence, NumberValidator as validatorNumberUtils, wechatJsonHandler };
