var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { asyncScript } from "../async-script/index.js";
const asyncAmapMap = () => new Promise((resolve) => {
  var _a;
  window.onAmapLoad = () => {
    resolve(true);
  };
  if ((_a = window == null ? void 0 : window.AMap) == null ? void 0 : _a.Map) {
    return resolve(true);
  }
});
const _AMapInteractor = class {
  constructor() {
    __publicField(this, "_amap");
    __publicField(this, "_amapMarker");
    __publicField(this, "_curruntLocation");
    this._amap = new window.AMap.Map("amap-container", {
      resizeEnable: true,
      zoom: 10
    });
  }
  static async getInstance() {
    if (!this._instance) {
      await asyncScript(this._amapSrc);
      await asyncAmapMap();
      this._instance = new _AMapInteractor();
    }
    return Promise.resolve(this._instance);
  }
  destroyed() {
    this._amap.destroy();
    delete this._amap;
    _AMapInteractor._instance = null;
  }
  search(city, input, callback, tips = true) {
    const autoOptions = {
      map: this._amap,
      city: city || "\u5168\u56FD",
      extensions: "all"
    };
    if (!tips) {
      delete autoOptions.map;
    }
    const placeSearch = new window.AMap.PlaceSearch(autoOptions);
    placeSearch.search(input, callback);
  }
  getGeocoderAddress(lngLat, callback) {
    window.AMap.plugin("AMap.Geocoder", () => {
      const geocoder = new window.AMap.Geocoder({
        map: this._amap,
        city: "\u5168\u56FD"
      });
      geocoder.getAddress(lngLat, callback);
    });
  }
  updateMarker(lngLat) {
    const marker = this._getMarker();
    marker.setPosition(lngLat);
    marker.setAnimation("AMAP_ANIMATION_DROP");
  }
  getMarkPosition() {
    const marker = this._getMarker();
    const position = marker.getPosition();
    if (position == null ? void 0 : position.lng) {
      return [position == null ? void 0 : position.lng, position == null ? void 0 : position.lat];
    }
    return [];
  }
  autolocation() {
    return new Promise((resolve, reject) => {
      var _a;
      if (this._curruntLocation) {
        resolve(this._curruntLocation);
        return;
      }
      (_a = this._amap) == null ? void 0 : _a.plugin("AMap.Geolocation", () => {
        const geolocation = new window.AMap.Geolocation({
          enableHighAccuracy: true,
          timeout: 1e5,
          buttonOffset: new window.AMap.Pixel(10, 20),
          zoomToAccuracy: true,
          buttonPosition: "RB",
          showCircle: false
        });
        geolocation.options.markerOptions.bubble = true;
        this._amap.addControl(geolocation);
        geolocation.getCurrentPosition();
        window.AMap.event.addListener(geolocation, "complete", (data) => {
          this._curruntLocation = data;
          resolve(data);
        });
        window.AMap.event.addListener(geolocation, "error", (error) => {
          console.warn("\u83B7\u53D6\u5B9A\u4F4D\u5931\u8D25", error);
          reject(error);
        });
      });
    });
  }
  getCurrentProvince() {
    return new Promise((resolve, reject) => {
      this.autolocation().then((data) => {
        const address = data.formattedAddress.slice(0, 2);
        import("../../carMessageData2.js").then((jsonData) => {
          const provinceData = jsonData.provinceData;
          for (const i in provinceData) {
            if (provinceData[i].province.slice(0, 2) === address) {
              if (data.formattedAddress.indexOf(provinceData[i].city) !== -1) {
                const provinceName = provinceData[i].letter.slice(0, 1);
                const letter = provinceData[i].letter.slice(1, 2);
                resolve({
                  province: provinceName,
                  letter
                });
                break;
              }
            }
          }
        }).catch((err) => {
          reject(err);
        });
      }).catch((err) => {
        reject(err);
      });
    });
  }
  _getMarker() {
    if (!this._amapMarker) {
      this._amapMarker = new window.AMap.Marker({ map: this._amap });
    }
    return this._amapMarker;
  }
  get amap() {
    return this._amap;
  }
};
let AMapInteractor = _AMapInteractor;
__publicField(AMapInteractor, "_instance", null);
__publicField(AMapInteractor, "_amapSrc", "https://webapi.amap.com/maps?v=1.3&key=2c7be58cca107ce087d7ef41a875a65f&plugin=AMap.Geocoder,AMap.Autocomplete,AMap.PlaceSearch,AMap.Geolocation&callback=onAmapLoad");
export { AMapInteractor, asyncAmapMap };
