import { m as main, l as lib, j as js, d as docxtemplater, F as FileSaver_min } from "../../main.js";
import { a as assign } from "../../lodash.js";
import "../../_commonjsHelpers.js";
const ExportBriefDataDocx = (tempDocxPath, data, fileName) => {
  main.filters.lower = function(input) {
    if (!input)
      return input;
    return input.toLowerCase();
  };
  function angularParser(tag) {
    tag = tag.replace(/^\.$/, "this").replace(/(’|‘)/g, "'").replace(/(“|”)/g, '"');
    const expr = main.compile(tag);
    return {
      get: function(scope, context) {
        let obj = {};
        const scopeList = context.scopeList;
        const num = context.num;
        for (let i = 0, len = num + 1; i < len; i++) {
          obj = assign(obj, scopeList[i]);
        }
        return expr(scope, obj);
      }
    };
  }
  lib.getBinaryContent(tempDocxPath, (error, content) => {
    if (error) {
      console.log(error);
    }
    const zip = new js(content);
    const doc = new docxtemplater(zip, { parser: angularParser });
    doc.setData(data);
    try {
      doc.render();
    } catch (error2) {
      const e = {
        message: error2.message,
        name: error2.name,
        stack: error2.stack,
        properties: error2.properties
      };
      console.log({ error: e });
      throw error2;
    }
    const out = doc.getZip().generate({
      type: "blob",
      mimeType: "application/vnd.openxmlformats-officedocument.wordprocessingml.document"
    });
    FileSaver_min.exports.saveAs(out, fileName);
  });
};
export { ExportBriefDataDocx };
