const checkFileType = (file) => new Promise((resolve, reject) => {
  if (!file) {
    reject("\u8BF7\u4E0A\u4F20\u6587\u4EF6");
    return;
  }
  if (!/\.(xls|xlsx|csv)$/.test(file.name.toLowerCase())) {
    reject("\u6587\u4EF6\u4E0A\u4F20\u5931\u8D25\uFF0C\u8BF7\u68C0\u67E5\u4F60\u7684\u6587\u4EF6\u683C\u5F0F");
    return false;
  }
  if (file.size >= 3145728) {
    reject("\u6587\u4EF6\u4E0A\u4F20\u5931\u8D25\uFF0C\u5927\u5C0F\u4E0D\u80FD\u8D85\u8FC73M");
    return false;
  }
  resolve(true);
});
const readFile = (file, options) => new Promise((resolve, reject) => {
  try {
    const fileReader = new FileReader();
    fileReader.onload = (ev) => {
      var _a;
      const result = (_a = ev.target) == null ? void 0 : _a.result;
      if (!result) {
        resolve([]);
      }
      import("../../xlsx.js").then((XLSX) => {
        const workbook = XLSX.read(result, options);
        const fileData = workbook.SheetNames.map((sheepName) => {
          var _a2;
          return XLSX.utils.sheet_to_json((_a2 = workbook.Sheets) == null ? void 0 : _a2[sheepName]);
        });
        resolve(fileData);
      });
    };
    fileReader.readAsBinaryString(file);
  } catch (err) {
    reject(err);
  }
});
const getXlsxFileData = (file, options) => new Promise((resolve, reject) => {
  checkFileType(file).then(() => {
    readFile(file, options).then((fileData) => {
      resolve(fileData);
    });
  }).catch((err) => reject(err));
});
export { checkFileType, getXlsxFileData, readFile };
