import { o as omitBy, b as isNil } from "../../lodash.js";
function removeNode(el) {
  const parent = el.parentNode;
  if (parent) {
    parent.removeChild(el);
  }
}
function htmlOpen(info) {
  let myWindow = window.open("", "", "width:100%,height:100%");
  if (!myWindow)
    return;
  myWindow.document.write(info);
  myWindow.document.close();
  myWindow.focus();
}
const judgeEmptyObjects = (obj) => {
  return !Object.keys(obj).length;
};
const RandomNumber = (length = 10) => {
  const pow = Math.pow(10, length);
  return Math.floor(Math.random() * pow);
};
const objectToFormData = (data) => {
  let formData = new FormData();
  for (const [key, value] of Object.entries(data)) {
    if (value !== null && value !== void 0) {
      if (value instanceof Object) {
        formData.append(key, JSON.stringify(value));
      } else {
        formData.append(key, value);
      }
    } else {
      formData.append(key, "");
    }
  }
  return formData;
};
const objectToArray = (data) => {
  let arr = [];
  for (const [key, value] of Object.entries(data)) {
    if (value !== null && value !== void 0) {
      arr.push(value);
    }
  }
  return arr;
};
const arrayToObject = (data) => {
  let arr = {};
  data.forEach((val) => {
    arr[val] = val;
  });
  return arr;
};
const filterEmpty = (value, isExclude) => {
  if (isExclude) {
    return false;
  }
  if (isNil(value) || value === "") {
    return true;
  }
  return false;
};
const filterEmptyValue = (jsonValue, excludeKeys = []) => {
  if (jsonValue && Object.keys(jsonValue).length > 0) {
    return omitBy(
      jsonValue,
      (value, key) => filterEmpty(value, excludeKeys.includes(key))
    );
  }
  return jsonValue;
};
const arrToObj = (arr) => {
  let obj = {};
  arr.forEach((item) => {
    obj[item] = item;
  });
  return obj;
};
const arrToObjTwo = (arr, arr2) => {
  let obj = {};
  arr.forEach((item, index) => {
    obj[arr2[index]] = item;
  });
  return obj;
};
const changeTableHead = (tableData, fieldName) => {
  const list = tableData.map((item) => {
    const obj = {};
    for (const k in item) {
      if (fieldName[k]) {
        obj[fieldName[k]] = item[k];
      }
    }
    return obj;
  });
  return list;
};
const transferred = (data) => {
  return data.replace(/<br>/g, "rn").replace(/&gt;/g, ">");
};
export { RandomNumber, arrToObj, arrToObjTwo, arrayToObject, changeTableHead, filterEmptyValue, htmlOpen, judgeEmptyObjects, objectToArray, objectToFormData, removeNode, transferred };
