import { d as dayjs } from "../../dayjs.min.js";
import { s as sha1 } from "../../sha1.js";
import { i as isFunction } from "../../lodash.js";
import "../../_commonjsHelpers.js";
const getBrowserFeature = () => {
  var _a;
  const navigatorAlias = navigator || {};
  const windowAlias = window || {};
  const screenAlias = windowAlias.screen || {};
  const pluginMap = {
    pdf: "application/pdf",
    qt: "video/quicktime",
    realp: "audio/x-pn-realaudio-plugin",
    wma: "application/x-mplayer2",
    dir: "application/x-director",
    fla: "application/x-shockwave-flash",
    java: "application/x-java-vm",
    gears: "application/x-googlegears",
    ag: "application/x-silverlight"
  };
  const browserFeature = {
    pdf: "",
    qt: "",
    realp: "",
    wma: "",
    dir: "",
    fla: "",
    res: "",
    java: "",
    gears: "",
    cookie: "",
    ag: ""
  };
  if (!new RegExp("MSIE").test(navigatorAlias.userAgent)) {
    if ((_a = navigatorAlias.mimeTypes) == null ? void 0 : _a.length) {
      for (const i in pluginMap) {
        if (Object.prototype.hasOwnProperty.call(pluginMap, i)) {
          const mimeType = navigatorAlias.mimeTypes[pluginMap[i]];
          browserFeature[i] = (mimeType == null ? void 0 : mimeType.enabledPlugin) ? "1" : "0";
        }
      }
    }
    if (isFunction(navigatorAlias.javaEnabled) && navigatorAlias.javaEnabled()) {
      browserFeature.java = "1";
    }
    if (isFunction(windowAlias.GearsFactory)) {
      browserFeature.gears = "1";
    }
    browserFeature.cookie = navigatorAlias.cookieEnabled ? "1" : "0";
  }
  const width = screenAlias.width;
  const height = screenAlias.height;
  browserFeature.res = width + "x" + height;
  return browserFeature;
};
const uuid = () => {
  const navigatorAlias = navigator || {};
  return sha1(`
    ${dayjs().valueOf()}
    ${navigatorAlias.userAgent || ""}
    ${navigatorAlias.platform || ""}
    ${JSON.stringify(getBrowserFeature())}
    ${Math.random()}`);
};
export { uuid };
