var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
const _EnvUtils = class {
  static setProHost(host) {
    _EnvUtils.proHost = host;
  }
  static isPro() {
    return document.domain === _EnvUtils.proHost || window.location.host === _EnvUtils.proHost;
  }
};
let EnvUtils = _EnvUtils;
__publicField(EnvUtils, "ua", navigator ? navigator.userAgent.toLowerCase() : "");
__publicField(EnvUtils, "screen", window ? window.screen : {
  height: 0,
  width: 0
});
__publicField(EnvUtils, "isWx", () => /micromessenger/i.test(_EnvUtils.ua));
__publicField(EnvUtils, "isAndroid", () => /android/i.test(_EnvUtils.ua));
__publicField(EnvUtils, "isIphone", () => /iphone/i.test(_EnvUtils.ua));
__publicField(EnvUtils, "isIphoneX", () => _EnvUtils.isIphone() && _EnvUtils.screen.height === 812 && _EnvUtils.screen.width === 375);
__publicField(EnvUtils, "isIphone678", () => _EnvUtils.isIphone() && _EnvUtils.screen.height === 667 && _EnvUtils.screen.width === 375);
__publicField(EnvUtils, "isIphone678Plus", () => _EnvUtils.isIphone() && _EnvUtils.screen.height === 736 && _EnvUtils.screen.width === 414);
__publicField(EnvUtils, "isIphone5", () => _EnvUtils.isIphone() && _EnvUtils.screen.height === 568 && _EnvUtils.screen.width === 320);
__publicField(EnvUtils, "iPhoneSystemVersion", () => {
  const uaMatch = _EnvUtils.ua.match(/cpu iphone os (.*?) like mac os/);
  const iosVersion = uaMatch ? uaMatch[1].replace(/^(\d+)_(\d+)\S*/, "$1.$2") : "0";
  return parseInt(iosVersion, 10);
});
__publicField(EnvUtils, "proHost", "");
const _WechatSdk = class {
  static getInstance() {
    return new Promise((resolve) => {
      if (_WechatSdk._wechatSdk) {
        resolve(this._wechatSdk);
      } else {
        import("../../index4.js").then(function(n) {
          return n.i;
        }).then((wx) => {
          _WechatSdk._wechatSdk = wx;
          resolve(wx);
          window.wx = wx;
        });
      }
    });
  }
};
let WechatSdk = _WechatSdk;
__publicField(WechatSdk, "_wechatSdk", null);
const enCodeUrlParams = (params, excules = []) => {
  const paramsArray = [];
  Object.keys(params).forEach((key) => {
    const exculesKeys = [...excules, "returnShopProductUrl"];
    if (exculesKeys.includes(key)) {
      return key;
    }
    if (params[key]) {
      paramsArray.push(
        encodeURIComponent(key) + "=" + encodeURIComponent(params[key])
      );
    } else {
      if (typeof params[key] === "number" && !isNaN(Number(params[key]))) {
        paramsArray.push(
          encodeURIComponent(key) + "=" + encodeURIComponent(params[key])
        );
      } else {
        paramsArray.push(encodeURIComponent(key) + "=");
      }
    }
  });
  return paramsArray.join("&");
};
const DEFAULT_DOCUMENT_TITLE = "xxxxx";
const SCPRIT_ID = "WX_SCRIPT";
const getWechatEnv = (() => {
  const envConfig = {
    isWechat: false,
    isMiniprogram: false
  };
  if (EnvUtils.isWx()) {
    WechatSdk.getInstance().then((wx) => {
      wx.miniProgram.getEnv((res) => {
        if (res.miniprogram) {
          envConfig.isMiniprogram = true;
        } else {
          envConfig.isWechat = true;
        }
      });
    });
  }
  return {
    envConfig
  };
})();
const wechatJsonHandler = (data) => {
  const targetScript = document.getElementById(SCPRIT_ID);
  if (targetScript) {
    document.body.removeChild(targetScript);
  }
  if (data && typeof data === "string") {
    try {
      const response = JSON.parse(data);
      if (!response.signature) {
        return;
      }
      WechatUtils.setWechatJson(response);
      if (!EnvUtils.isWx()) {
        return;
      }
      WechatSdk.getInstance().then((wx) => {
        wx.miniProgram.getEnv((res) => {
          if (!res.miniprogram) {
            WechatUtils.initWechat();
          }
        });
      });
    } catch (err) {
      console.error(`\u5FAE\u4FE1\u521D\u59CB\u5316\u5931\u8D25 ${err}`);
    }
  }
};
class WechatUtils {
  static get config() {
    return EnvUtils.isPro() ? this.WECHAT_SINGE_CONFIG.pro : this.WECHAT_SINGE_CONFIG.test;
  }
  static get _isFinishGetSignature() {
    return !!this._wechatJson.signature;
  }
  static get wechatEnv() {
    return getWechatEnv.envConfig;
  }
  static init() {
    this._retryTime = 0;
    if (!this._isInWechat) {
      return;
    }
    this._getSignatureByJsonp();
  }
  static initShareConfig(config, callback) {
    if (!this._isInWechat) {
      return;
    }
    if (config) {
      this._shareConfig = {
        title: (config == null ? void 0 : config.title) || DEFAULT_DOCUMENT_TITLE,
        desc: (config == null ? void 0 : config.desc) || "xxxxx",
        link: (config == null ? void 0 : config.link) || window.location.href,
        imgUrl: (config == null ? void 0 : config.imgUrl) || `${window.location.origin}/logo.png`,
        callback
      };
      this._retryTimer = 0;
    }
    if (!this._isInitSuccess && this._retryTime < this.MAX_RETRY_TIME) {
      this._retryTime += 1;
      clearTimeout(this._retryTimer);
      this._retryTimer = window.setTimeout(() => {
        this.initShareConfig();
      }, this.RETRY_INTERVAL);
      return;
    }
    const shareObj = {
      title: this._shareConfig.title,
      desc: this._shareConfig.desc,
      link: this._shareConfig.link,
      imgUrl: this._shareConfig.imgUrl,
      trigger: () => {
        console.log("\u7528\u6237\u70B9\u51FB\u53D1\u9001\u7ED9\u670B\u53CB");
      },
      success: () => {
        var _a, _b;
        console.log("\u5206\u4EAB\u6210\u529F");
        (_b = (_a = this._shareConfig).callback) == null ? void 0 : _b.call(_a);
      },
      cancel: () => {
        console.log("\u5DF2\u53D6\u6D88\u5206\u4EAB");
      }
    };
    WechatSdk.getInstance().then((wx) => {
      wx.onMenuShareAppMessage(shareObj);
      wx.onMenuShareQQ(shareObj);
      wx.onMenuShareTimeline(shareObj);
    });
  }
  static setWechatJson(data) {
    this._wechatJson = {
      signature: data.signature,
      timestamp: data.timestamp,
      nonceStr: data.nonce || data.nonceStr,
      ticket: data.ticket,
      nonce: data.nonce
    };
  }
  static initWechat(callback) {
    return new Promise((resolve) => {
      if (!this._isFinishGetSignature) {
        return;
      }
      WechatSdk.getInstance().then((wx) => {
        wx.config({
          debug: false,
          appId: this.config.appid,
          timestamp: this._wechatJson.timestamp,
          nonceStr: this._wechatJson.nonceStr,
          signature: this._wechatJson.signature,
          jsApiList: this.WECHAT_API_LIST
        });
        wx.ready(() => {
          this.initShareConfig();
          this._isInitSuccess = true;
          callback == null ? void 0 : callback();
          resolve(this._wechatJson);
        });
        wx.error((err) => {
          console.log("wx.error", err);
        });
      });
    });
  }
  static getWechatAppType() {
    if (this.wechatEnv.isMiniprogram) {
      return "WMP";
    }
    if (this.wechatEnv.isWechat) {
      return "JSAPI";
    }
    return "H5";
  }
  static _getSignatureByJsonp() {
    WechatSdk.getInstance().then((wx) => {
      wx.miniProgram.getEnv((res) => {
        if (!res.miniprogram) {
          window.wechatJsonHandler = wechatJsonHandler;
          const signUrl = EnvUtils.isAndroid() ? window.location.href.split("#")[0] : this.entryUrl;
          const params = {
            openid: this.config.openid,
            weappNo: this.config.weappNo,
            fxurl: signUrl,
            callback: "window.wechatJsonHandler"
          };
          const script = document.createElement("script");
          script.id = SCPRIT_ID;
          script.src = `${this.config.getSignatureUri}${enCodeUrlParams(params)}`;
          document.body.insertBefore(script, document.body.firstChild);
        }
      });
    });
  }
}
__publicField(WechatUtils, "entryUrl", "");
__publicField(WechatUtils, "WECHAT_API_LIST", [
  "checkJsApi",
  "updateAppMessageShareData",
  "updateTimelineShareData",
  "onMenuShareTimeline",
  "onMenuShareAppMessage",
  "onMenuShareQQ",
  "hideOptionMenu",
  "showOptionMenu",
  "getLocation",
  "chooseImage",
  "uploadImage",
  "downloadImage",
  "previewImage",
  "closeWindow"
]);
__publicField(WechatUtils, "MAX_RETRY_TIME", 5);
__publicField(WechatUtils, "RETRY_INTERVAL", 500);
__publicField(WechatUtils, "WECHAT_SINGE_CONFIG", {
  test: {
    appid: "xxxxx",
    weappNo: "xxxxx",
    redirectUri: "xxxxx/redirect?backUrl=",
    getSignatureUri: "xxxxx/getSignature?",
    openid: "xxxxx"
  },
  pro: {
    appid: "xxxxx",
    weappNo: "xxxxx",
    redirectUri: "http://xxxxx/redirect?backUrl=",
    getSignatureUri: "https://xxxxx/getSignature?",
    openid: "xxxxx"
  }
});
__publicField(WechatUtils, "_wechatJson", {
  signature: "",
  timestamp: "",
  nonce: "",
  ticket: ""
});
__publicField(WechatUtils, "_shareConfig", {
  title: "\u5206\u4EAB\u6807\u9898",
  desc: "\u5206\u4EAB\u5185\u5BB9",
  link: window.location.href,
  imgUrl: `${window.location.origin}/logo.png`,
  callback: () => {
    console.log("share callback");
  }
});
__publicField(WechatUtils, "_isInWechat", EnvUtils.isWx());
__publicField(WechatUtils, "_isInitSuccess", false);
__publicField(WechatUtils, "_retryTime", 0);
__publicField(WechatUtils, "_retryTimer");
export { WechatSdk, WechatUtils, wechatJsonHandler };
