import { AmapLocationAddressType, AmapProvinceType } from './interface';
declare const asyncAmapMap: () => Promise<unknown>;
/**
 * 高德地图相关操作
 * 为了节省资源，采用有异步加载，操作基本为异步操作，请留意
 *
 * @class AMapInteractor
 */
declare class AMapInteractor {
    private static _instance;
    private static _amapSrc;
    static getInstance(): Promise<AMapInteractor>;
    /** 高德实例 */
    private _amap?;
    /** 高德地图标记 */
    private _amapMarker?;
    /** 当前定位 */
    private _curruntLocation?;
    constructor();
    destroyed(): void;
    search(city: string, input: string, callback: () => void, tips?: boolean): void;
    getGeocoderAddress(lngLat: any[], callback: any): void;
    /**
     * 更新标记
     * @param lngLat 经纬度 [116.397428, 39.90923]
     */
    updateMarker(lngLat: any[]): void;
    getMarkPosition(): any[];
    /**
     * 获取当前定位
     * @returns
     */
    autolocation(): Promise<AmapLocationAddressType>;
    /**
     * 获取自动定位省份
     * @returns
     */
    getCurrentProvince(): Promise<AmapProvinceType>;
    /** 获取地址编码转换数据 */
    private _getMarker;
    get amap(): any;
}
export { AMapInteractor, asyncAmapMap };
