/**
 * 获取文件流资源
 * 后台固定名字response,带headers等信息的返回结果
 * @param {*} res
 * @param {*} down 是否下载
 * @param {*} errorFun
 * @param {*} name
 * @returns
 */
/**
 * 获取下载文件的filename
 * @param {String} cds requonse headers['Content-Disposition']
 */
/**
 * 获取资源路径
 * @param {*} data
 * @param {*} tranformmation
 * @returns
 */
export declare function getFileUrl(data: Blob, tranformmation?: boolean): string | false | Blob;
/**
 * 下载文件
 * @param {*} data 数据
 * @param {*} filename 文件名。格式
 * @param {*} tranformmation 是否需要转换
 */
export declare function downloadFile(data: Blob, filename?: string, tranformmation?: boolean): void;
/**
 * 尝试转换成json (如果文件流本身是json格式切勿使用该方法)
 * @param {*} arraybuffer
 */
export declare function arraybufferToJson(arraybuffer: Uint8Array): any;
/**
 * 根据接口获取文件并下载
 * @param action 接口路径
 * @param params 接口请求参数
 * @param method 接口请求方式
 * @param parent 生成form父级元素
 */
export declare const formDataDownFile: (action: string, params: any, method?: string, parent?: string) => void;
export declare const createInputElement: (name: string, value: string, type?: string) => HTMLInputElement;
/**
 * 导出excel内容
 * @param fileName 文件名称
 * @param pageName 工作表名称
 */
export declare const exportExcel: (fileName?: string, pageName?: string) => void;
/**
 * 获取页面表格内容
 * @returns
 */
export declare const getHtmlTableData: () => {
    ths: string[];
    trs: string[][];
};
/**
 * 导出CSV
 * @param fileName
 */
export declare const downloadTableToCSV: (fileName: string) => void;
