import { KeyMapAny } from "../../interface";
/**
 * 删除节点
 * @param {删除节点父级} el
 */
export declare function removeNode(el: Element): void;
/**
* 将html字符串打开成新页面
* @param {html的字符串} info
*/
export declare function htmlOpen(info: string): void;
/**
 * 判断是否为空对象
 * @param obj
 */
export declare const judgeEmptyObjects: (obj: Object) => boolean;
/**
 * 随机生成数字
 * @param length 生成数字长度 （默认为10）
 * @returns
 */
export declare const RandomNumber: (length?: number) => number;
/**
 * 对象转formData
 * @param data
 */
export declare const objectToFormData: (data: object) => FormData;
/**
 * 对象转一维数组
 * @param data
 */
export declare const objectToArray: (data: object) => Array<Object>;
/**
 * 一维数组转对象
 * @param data
 */
export declare const arrayToObject: (data: Array<string>) => KeyMapAny;
/**
 * 过滤空元素
 * @param jsonValue
 * @param excludeKeys 排除字段
 * @returns object
 */
export declare const filterEmptyValue: (jsonValue: KeyMapAny<any>, excludeKeys?: string[]) => any;
/**
 * 数组转换对象（当前值作为key）
 * @param arr
 * @returns
 */
export declare const arrToObj: (arr: Array<string>) => OBJ_STRING;
/**
 * 数组转对象（指定顺序对应的key）
 * @param arr 需转换的数组
 * @param arr2 需转换的数组对应的key列表
 * @returns
 */
export declare const arrToObjTwo: (arr: Array<string>, arr2: Array<string>) => OBJ_STRING;
export interface OBJ_STRING {
    [key: string]: string;
}
export declare const changeTableHead: (tableData: Array<OBJ_STRING>, fieldName: OBJ_STRING) => OBJ_STRING[];
export declare const transferred: (data: string) => string;
