/**
 * 小数位四舍五入
 * @param num
 * @param precision 默认保留2位小数点
 * @returns {number}
 */
type NumberOrString = number | string;
/**
 * 精确浮点数 加减乘除
 * @param arg1
 * @param arg2
 * @param precision 保留小数点位数，不传则默认保留两位小数点
 * @returns {*}
 */
export declare const numberUtils: {
    add: (arg1: NumberOrString, arg2: NumberOrString, precision?: number) => number;
    sub: (arg1: NumberOrString, arg2: NumberOrString, precision?: number) => number;
    mul: (arg1: NumberOrString, arg2: NumberOrString, precision?: number) => number;
    div: (arg1: NumberOrString, arg2: NumberOrString, precision?: number) => number;
    toPercent: (arg: number) => string;
};
export {};
