import { KeyMapAny } from "../../../interface";
/**
 * 获取Url参数
 * @param search
 *
 * @return UrlParamsType
 */
export declare const getUrlQuerys: (search?: string) => KeyMapAny<string>;
/**
 * 获取单个Url参数
 * @param key
 * @param search
 *
 * @return string
 */
export declare const getUrlQuery: (key: string, search?: string) => string;
/**
 * 链接参数转义
 * @param params
 * @returns
 */
export declare const enCodeUrlParams: (params: KeyMapAny<string | undefined>, excules?: string[]) => string;
/**
 * @params
 * params:
 * url: 拼接部分的文件地址
 * @Description: xml获取类似gbk格式的html进行转编码 'utf-8'/'gbk'
 */
export declare const overrideMimeTypeXML: (params: {
    url: string;
    charset: string;
}) => Promise<string>;
/**
 * 获取Url上的模板
 * @returns
 */
export declare const getUrlTemplateCode: () => string;
