import validateStringUtils from './string';
import validatorNumberUtils from './number';
/**
 * 验证证件号码
 * @param certificateNo
 * @param certificateType
 * @returns string
 */
declare const validateCertificateNo: (certificateNo: string, certificateType: string) => string;
/**
 * 验证邮箱
 * @param email
 * @returns string
 */
declare const validateEmail: (email: string) => string;
/**
 * 验证联系方式
 * @param phoneNumber
 * @param isMobile
 * @returns string
 */
declare const validatePhoneNumber: (phoneNumber: string, isMobile?: boolean) => string;
/**
 * 车架号验证
 * @param vehicleFrameNo
 * @returns string
 */
declare const validateVehicleFrameNo: (vehicleFrameNo: string) => string;
/**
 * 发动机验证
 * @param engineNo
 * @returns string
 */
declare const validateVehicleEngineNo: (engineNo: string) => string;
/**
 * 车牌号验证
 * @param vehicleLicense
 * @param isNonMotor
 * @returns string
 */
declare const validateVehicleLicence: (vehicleLicence: string, isNonMotor?: boolean) => string;
export { validateCertificateNo, validateEmail, validatePhoneNumber, validateVehicleFrameNo, validateVehicleEngineNo, validateVehicleLicence, validateStringUtils, validatorNumberUtils, };
